GNU bug report logs - #38136
[PATCH] Make gnus-group-get-new-news a non blocking thread

Please note: This is a static page, with minimal formatting, updated once a day.
Click here to see this page with the latest information and nicer formatting.

Package: emacs,gnus; Severity: wishlist; Reported by: dick.r.chiang@HIDDEN; Keywords: patch; dated Fri, 8 Nov 2019 14:57:04 UTC; Maintainer for emacs is bug-gnu-emacs@HIDDEN.

Message received at 38136 <at> debbugs.gnu.org:


Received: (at 38136) by debbugs.gnu.org; 20 Nov 2019 13:00:24 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Wed Nov 20 08:00:24 2019
Received: from localhost ([127.0.0.1]:49105 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1iXPap-000619-0k
	for submit <at> debbugs.gnu.org; Wed, 20 Nov 2019 08:00:24 -0500
Received: from mout.gmx.net ([212.227.17.20]:60191)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <michael.albinus@HIDDEN>) id 1iXPan-00060p-Cj
 for 38136 <at> debbugs.gnu.org; Wed, 20 Nov 2019 08:00:22 -0500
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/simple; d=gmx.net;
 s=badeba3b8450; t=1574254806;
 bh=v1wDRZvEJA5qA1HNfMHtjTt+Ad7ax7c2AsJJax9poNg=;
 h=X-UI-Sender-Class:From:To:Cc:Subject:References:Date:In-Reply-To;
 b=jwoLo2egC/i0rOwfT3aPNSTYLhzj2XJNFkEfP0Ya9Ed6uaK3YOh/FBmSs2fugmOKb
 ywJLj/2gosNgCj7alWUPZF/vTK/WVKA7kBEDvarPz0K04RK1Jt0TDmZeQKx7po+VNv
 CkH0NLQt9rxu9tweYS7QECbPds9lbjD15r14jeZI=
X-UI-Sender-Class: 01bb95c1-4bf8-414a-932a-4f6e2808ef9c
Received: from detlef.gmx.de ([212.86.46.89]) by mail.gmx.com (mrgmx104
 [212.227.17.168]) with ESMTPSA (Nemesis) id 1Mnpnm-1i5RV93MlO-00pIyy; Wed, 20
 Nov 2019 14:00:05 +0100
From: Michael Albinus <michael.albinus@HIDDEN>
To: Robert Pluim <rpluim@HIDDEN>
Subject: Re: bug#38136: [PATCH] Make gnus-group-get-new-news a non blocking
 thread
References: <87imnu1knq.fsf@dick> <87r22h7mka.fsf@HIDDEN>
 <87sgmrouxk.fsf@HIDDEN> <8736emaxw6.fsf@HIDDEN>
 <87sgmlsgxx.fsf@HIDDEN> <87zhgsncno.fsf@HIDDEN>
 <87lfscesen.fsf@dick> <871ru4n58t.fsf@HIDDEN>
 <m21ru4p3t8.fsf@HIDDEN> <87ftijdcay.fsf@HIDDEN>
 <874kyykd8b.fsf@HIDDEN> <87sgmiyd6m.fsf@HIDDEN>
 <m2pnhmwwo7.fsf@HIDDEN>
Date: Wed, 20 Nov 2019 14:00:04 +0100
In-Reply-To: <m2pnhmwwo7.fsf@HIDDEN> (Robert Pluim's message of "Wed, 20
 Nov 2019 13:37:44 +0100")
Message-ID: <87pnhmwvmz.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/27.0.50 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain; charset=utf-8
Content-Transfer-Encoding: quoted-printable
X-Provags-ID: V03:K1:iWZ84ZCuqw3WfF9/7sge76H4NTb9AaHXb7AuqVcc+ns8l1DCpEg
 vQ1le/xETgfPRc2kRCUC6CzCvdCiXYl3nqgkNCU4XdlFKrPllbhk1V5FMcIH4QQmiHbW8WM
 aGCRo2hll+bh9Jz8pd7Gm3nJA1F3PzZE54P/LcFO5uQiF3J9oszRqpkB9TgNOCI+8JxzbkS
 zQgy/51UXF9lTaF/qwTow==
X-Spam-Flag: NO
X-UI-Out-Filterresults: notjunk:1;V03:K0:Wod/KDSBBcQ=:ViSrRVTqsdi/Bt5/VmBhd2
 wa7NKof2fqkUKaRmqh+gn50mlJ4mWAAhRgJOQ72nnvaIzOgKov7hdDbaYwYUDgzsWWPPzH6me
 IqmvNJN7XsgUhl5tAYJyDjmeEssmtOQIPdpxu7tERFRqf0Wc7YkSWeLQxFqMjzaTe3GWvI4Dd
 RDC+vsRh69ILlS7TPP1a9emKYatb5cJtMvTe9FOlGlG1JSriRWoLcSl3aqUgs1feRfVrLAc/f
 qHiDF0cNT4Whwt/ZjwiHfXSFXoLd3ZVDd/0hNAqjXLGVO2e0BG0dtWHgVlemEra4krOif2rnA
 87tvBGB86g01O6I6zcPusi+RQbSHSJ0/UK0PN0IiRin2H96zAx40BkI8Ld33cJt6nAC0OxCK/
 oHmINtZNm3N9j4BOTZUosHkCBDlMMUt9RTc0B64lYvS9MDnrXZYo0baryFVljRRwYLy4wWxUL
 aotA3QBS1tpS2paTLEsDTQIGvMCwJ5KqkIHoXKWCFisxaSwi6derW2HMxZnUwvv7mi6wjET00
 aJUwCJBiINulsNyK9TXjLyEXuRxjIUZaTjslBhSXyofU1ozgB2AqrwEcAWLPNJaPpSuiwo/dV
 brpZD4T8ZJawPIx5flW7KKBZvYTeqdc6lTtvimERJDV6w+lUn7JTwe3xhq29HDHbCFqBiV0E0
 rapFmpB5CWHp2Pfm2SuAIsDkFl6fpH5p2Q4Rt92vd9Jmnvm3WNQ80QeFCJtWXunbv5EwL1k1c
 l9GFM2985lQqCDAXCpjEHoO4+OfE91R8u3tE2u2KadcxlN4ni4vvigXSA5A8hWoY8RunmqmEc
 qV7tICnMSXdzKULkxwYZRIB7IjSDxOnz85VXAbuNnLd5eTq3sk1CeuUhKYw/hrBb61ehIxnJx
 aEjIznHNyGqfx9/Lo1mTPs6g7adSExthGUIjHvX7NlD9xUPCCAdFF8mnDv5S9E34XWsRLh0gb
 iUeURiJTFxZQ7F4GscWvcIIfLw89dQwBUbtomFrGQrDiJqy9Tg3ZUekiaAUYtbPUMqpxurEqi
 sKL+2skL9Wr+S0n7QqIzwEbLT1SlHz6sux/k9Qz00gxqpLLdoFU3X0VaCLOup1Z4eva2tSDxj
 8ISnYe280upH1jy8jl4y3aZ3Vpj/Qcy51l63Loi5tpDoYsLWNHtBMSwIAMco6V4R/cQ7uJiTu
 4Pge2Xf+2/GUQmbdBzIJJjGuWyVTIWcrJ49RHSpkBeErXu6m4knAXl4D3iLOJSe4tIVbPUqMl
 E+iTRjy764wikZHi/AklH4tTyb4TLDECXAU+7j7iej/GX9jQP2I+XxrAychc=
X-Spam-Score: -0.7 (/)
X-Debbugs-Envelope-To: 38136
Cc: Eric Abrahamsen <eric@HIDDEN>,
 Lars Ingebrigtsen <larsi@HIDDEN>, dick.r.chiang@HIDDEN,
 38136 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.7 (-)

Robert Pluim <rpluim@HIDDEN> writes:

> Doesn=CA=BCt this already exist?
>
>     M-x debbugs-gnu
>     Hit 't' on the bugs that you=CA=BCre interested in
>     quit debbugs
>     M-x debbugs-gnu
>     Erase the default severities, say 'tagged', then hit RET at the next =
prompt
>     Hey presto, debbugs-gnu with only the bugs you hit 't' on earlier.
>
> If you want to add a bug to that list:
>
>     M-x debbugs-gnu-bug
>     type the bug number, RET
>     Hit 't'
>
> Now the next time you run debbugs-gnu as above that bug will appear as
> well.

Sure (and I use it every single day). But I understood the request as
"Pls give me one gnus summary buffer containing all messages of bugs I
have tagged locally". This doesn't exist yet.

> Robert

Best regards, Michael.




Information forwarded to bug-gnu-emacs@HIDDEN, bugs@HIDDEN:
bug#38136; Package emacs,gnus. Full text available.

Message received at 38136 <at> debbugs.gnu.org:


Received: (at 38136) by debbugs.gnu.org; 20 Nov 2019 12:38:04 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Wed Nov 20 07:38:04 2019
Received: from localhost ([127.0.0.1]:49064 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1iXPF8-0005KA-Gs
	for submit <at> debbugs.gnu.org; Wed, 20 Nov 2019 07:37:58 -0500
Received: from mail-wm1-f68.google.com ([209.85.128.68]:38033)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <rpluim@HIDDEN>) id 1iXPF2-0005Jn-UQ
 for 38136 <at> debbugs.gnu.org; Wed, 20 Nov 2019 07:37:55 -0500
Received: by mail-wm1-f68.google.com with SMTP id z19so7646932wmk.3
 for <38136 <at> debbugs.gnu.org>; Wed, 20 Nov 2019 04:37:52 -0800 (PST)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=gmail.com; s=20161025;
 h=from:to:cc:subject:references:date:in-reply-to:message-id
 :mime-version:content-transfer-encoding;
 bh=Ic2WJK/DA1h/j0rlV0gBs3JN92p8ROA2dvYPBNQvF3k=;
 b=LK6w/wLoPINGFiXt4n+/y4s+OmhICZuHrPrLvhca/5xE7VJ2RzZr45kp7OX+mAgGuw
 wTIV1fqteqocrb+9t3QliDgRrioFRZzteRJa6XrbDvkRBXIMTH8KwN9lfzdkHdC7NQRn
 GpV/gpEtu8WGWy6ycOmozGHFD1mZPbjzLfU5xdS1CqGKiD2hy/rjqG56QRaYjGW+jGlC
 U8chU1BPhxMkSU3oMakYh5xXT2p7aOsmlBUdcumzVmqD2P3k4TiDRIKJ0/7GJtvabkQp
 wPNm6xet5CZYNfg1Vh3DI+HxwososeabW0UmHdBQABXgC5cuYGJ2nCyDijzwI/2OtvQc
 JbRg==
X-Google-DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=1e100.net; s=20161025;
 h=x-gm-message-state:from:to:cc:subject:references:date:in-reply-to
 :message-id:mime-version:content-transfer-encoding;
 bh=Ic2WJK/DA1h/j0rlV0gBs3JN92p8ROA2dvYPBNQvF3k=;
 b=mLq0H1y98LWmEtkIIEanOME0SKBHOGNN776EVbch8VokXGInxUWvLG6QEXkilwdRj7
 Zl7mLWmjuwyyM9pgC1wDyZEZaxRYCykn4NVB/sTP5FinhAnBm8RirjKFeCfzHDXB0S3s
 P8E/+/X2y1oDQWNo6NV1klHVX7aNkah9gZZLQv6dd3JbscKspjQ9Ra4uM5Lppq6g3RIn
 0d3zsnbXo94I6Cjw5Iu8orxMIK2Ua5Idv8mm0JPlXY4cPy7cXKZTNzBA4Gt78NuvjSsU
 k33Lou5V4Lukyw9IP1MWC1Ik1W1EXhpnm7EvyN0zLn3w+TG74S1JTIKNEgCuSLArdpQZ
 C69A==
X-Gm-Message-State: APjAAAUX+fWteiqtymMFxIi22dI10SqpMqTp/l4SsTeW8LPzKq1kLVUb
 WbdrMER7xVNUB8wqFXP1z67h+kn91JY=
X-Google-Smtp-Source: APXvYqzdH3YPxooLa+YQvDN2M9zMwqob9vHbGImrm4QdQ3zkYJ1oViMurruxpPocXMhNSyCGGaRxTA==
X-Received: by 2002:a1c:740a:: with SMTP id p10mr2922249wmc.121.1574253466555; 
 Wed, 20 Nov 2019 04:37:46 -0800 (PST)
Received: from rpluim-mac ([149.5.228.1])
 by smtp.gmail.com with ESMTPSA id o1sm31333277wrs.50.2019.11.20.04.37.45
 (version=TLS1_3 cipher=TLS_AES_256_GCM_SHA384 bits=256/256);
 Wed, 20 Nov 2019 04:37:45 -0800 (PST)
From: Robert Pluim <rpluim@HIDDEN>
To: Michael Albinus <michael.albinus@HIDDEN>
Subject: Re: bug#38136: [PATCH] Make gnus-group-get-new-news a non blocking
 thread
References: <87imnu1knq.fsf@dick> <87r22h7mka.fsf@HIDDEN>
 <87sgmrouxk.fsf@HIDDEN> <8736emaxw6.fsf@HIDDEN>
 <87sgmlsgxx.fsf@HIDDEN> <87zhgsncno.fsf@HIDDEN>
 <87lfscesen.fsf@dick> <871ru4n58t.fsf@HIDDEN>
 <m21ru4p3t8.fsf@HIDDEN> <87ftijdcay.fsf@HIDDEN>
 <874kyykd8b.fsf@HIDDEN> <87sgmiyd6m.fsf@HIDDEN>
Date: Wed, 20 Nov 2019 13:37:44 +0100
In-Reply-To: <87sgmiyd6m.fsf@HIDDEN> (Michael Albinus's message of "Wed, 20
 Nov 2019 12:55:45 +0100")
Message-ID: <m2pnhmwwo7.fsf@HIDDEN>
MIME-Version: 1.0
Content-Type: text/plain; charset=utf-8
Content-Transfer-Encoding: quoted-printable
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 38136
Cc: Eric Abrahamsen <eric@HIDDEN>,
 Lars Ingebrigtsen <larsi@HIDDEN>, dick.r.chiang@HIDDEN,
 38136 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

>>>>> On Wed, 20 Nov 2019 12:55:45 +0100, Michael Albinus <michael.albinus@=
gmx.de> said:

    Michael> Lars Ingebrigtsen <larsi@HIDDEN> writes:
    >> That wouldn't be very difficult to add to debbugs-gnu, actually.  It
    >> already has the concept of "marked" bugs, so there could be a command
    >> like, say, `debbugs-gnu-show-marked' that just shows that list of bu=
gs.

    Michael> Patches welcome :-)

    Michael> I'm not so fluid in writing gnus patches, so don't count on me.

Doesn=CA=BCt this already exist?

    M-x debbugs-gnu
    Hit 't' on the bugs that you=CA=BCre interested in
    quit debbugs
    M-x debbugs-gnu
    Erase the default severities, say 'tagged', then hit RET at the next pr=
ompt
    Hey presto, debbugs-gnu with only the bugs you hit 't' on earlier.

If you want to add a bug to that list:

    M-x debbugs-gnu-bug
    type the bug number, RET
    Hit 't'

Now the next time you run debbugs-gnu as above that bug will appear as
well.

Robert




Information forwarded to bug-gnu-emacs@HIDDEN, bugs@HIDDEN:
bug#38136; Package emacs,gnus. Full text available.

Message received at 38136 <at> debbugs.gnu.org:


Received: (at 38136) by debbugs.gnu.org; 20 Nov 2019 11:56:10 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Wed Nov 20 06:56:10 2019
Received: from localhost ([127.0.0.1]:49042 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1iXOag-0002Kq-BH
	for submit <at> debbugs.gnu.org; Wed, 20 Nov 2019 06:56:10 -0500
Received: from mout.gmx.net ([212.227.17.20]:50925)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <michael.albinus@HIDDEN>) id 1iXOac-0002KG-Ra
 for 38136 <at> debbugs.gnu.org; Wed, 20 Nov 2019 06:56:07 -0500
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/simple; d=gmx.net;
 s=badeba3b8450; t=1574250948;
 bh=regcP1yYuFeULyLzk4/BFEhMDRC1S2/EWP4CH+dDtns=;
 h=X-UI-Sender-Class:From:To:Cc:Subject:References:Date:In-Reply-To;
 b=Ej17SP7oQavZZDr3QA2mCnRO0eMoWRzqIXZTXiIQJLEuc2k6serSKwm7nbxiaEKUB
 FH6y3RRA3TX8GaiKZplNjQwXHRsiLZxUEgJU1VPTcRNyH7BRm+c6auuoSrKjQzTGvu
 d9oIYD5ZBcGXoEx2Ey8anr+OFAGFIsRS8EZWHm08=
X-UI-Sender-Class: 01bb95c1-4bf8-414a-932a-4f6e2808ef9c
Received: from detlef.gmx.de ([212.86.46.89]) by mail.gmx.com (mrgmx104
 [212.227.17.168]) with ESMTPSA (Nemesis) id 1N1Obb-1hs2Ln08Ff-012pkB; Wed, 20
 Nov 2019 12:55:48 +0100
From: Michael Albinus <michael.albinus@HIDDEN>
To: Lars Ingebrigtsen <larsi@HIDDEN>
Subject: Re: bug#38136: [PATCH] Make gnus-group-get-new-news a non blocking
 thread
References: <87imnu1knq.fsf@dick> <87r22h7mka.fsf@HIDDEN>
 <87sgmrouxk.fsf@HIDDEN> <8736emaxw6.fsf@HIDDEN>
 <87sgmlsgxx.fsf@HIDDEN> <87zhgsncno.fsf@HIDDEN>
 <87lfscesen.fsf@dick> <871ru4n58t.fsf@HIDDEN>
 <m21ru4p3t8.fsf@HIDDEN> <87ftijdcay.fsf@HIDDEN>
 <874kyykd8b.fsf@HIDDEN>
Date: Wed, 20 Nov 2019 12:55:45 +0100
In-Reply-To: <874kyykd8b.fsf@HIDDEN> (Lars Ingebrigtsen's message of "Wed,
 20 Nov 2019 12:18:28 +0100")
Message-ID: <87sgmiyd6m.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/27.0.50 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain
X-Provags-ID: V03:K1:CVASFi8KDiKQQZdEmMnfzvSr0hJnj8kG2TnhkejakY3YhZN+feI
 G7gtRELFQpXjqrwaX768FzPIJKxoVYj2d/TDicqORcOswUZoyqjgzcdqRqpIbdqJuxXJHZ1
 AdW1703VABhBQqcPZPddVRWQVMZnryepqWr/hrMcyv+R1tXZvOJB3MXxrF3S0GFaG912kqa
 5NRE9heCLVOi+n8VFxAYw==
X-Spam-Flag: NO
X-UI-Out-Filterresults: notjunk:1;V03:K0:IzZBdX6xo2I=:KeQnI5DvttuqOH0JFKZvqv
 PmwQpKL1Eh2rU6ccjdF6sWVyhDIYSZa8eBofcOtCPovq5r1Z5RQXlANVv5ahj7+EtxYTrO7fG
 Ufamhgd1CLNWNikdwY3TtwHwkTV6n9Bo2UFTR0g4dxD2AS++szjvRMFTyrE3RZkqlvqj/2zXa
 Wv+MDJB4XG1utQvF8myRKpludYIVOQLfv4qu2SUKFUHf0uyO4IpXzYE86FmiTgLYxvgiZE1MP
 TxyvpERnqPreE5BQ0oryfLMKhqDBkcUWvuTYT8B8I3iRZxW4IFu2xKqJ/wPp6xMVk844Rv2++
 lV6z3+U89bLCi0R+AhR1BHmLyMKruFU5SjiJ4nEV9Qr8zkkz0hljgmoj3tGrPs1stdoN3tZ5Y
 QtRVIcBVgNrCIMWd/3U6XtqM5bA4Pevv3HwDlKuabZEQPVpEKEt1FXy0qzDv/4IEvUf6qfQr5
 zJ0236t1mlTEMVAyI5gvOcW4Cqjyca0oE/tGHIxINoPSt/3a87m7yIOVpvlkfQMovd3Mxk5Df
 rduKg9R6++cL3iKR5ZDRSisOl7db3ZeKgi+AGr2Qgzk8aV8tUT/BCLUqH1r9DTjURoNY1Hn3e
 6tMP0NXs/xtZZxRrD/1pyX9GmikIjH/X8LHL/CqdTucj7r7Bl27eZri0Cx7Vra2vdTuMWQPAM
 iczosc4hkT32HT1cyKcu0AlpwYgYvXnxSYR9YdvVeQ+0591Oz22UtlfhXRvnGhOqS4MR7U5ZM
 W89Qa5LFTZjf4wqfEZXvQQ+uk9iuPe76ZO9OFeVleFkHzGHecovQngilLM3ztunqqo19e34xr
 +nxsZeh8+6DiKZZJJOUaih9v+xs/vdVWghsfq7M7F7+20pSaIAwu34VRa4I0lMJ8N1ohl78ol
 6D2Ddju7K+OVrxLjD+0MjDrUp9xYCuInirhDKz1ACMw/oT/kVeFOm0phFuH5OooUKYWCxHt02
 R2eCIeU7L7NvETGLiWUwFGAe/VZ8sImSlyyoj/YIRV2vDN+NBCEzw5PEw/zz5RWOXyaEQkN+o
 Rs2L0OKX6qe+ZGmKbEKnYv4egn6uvA2unUHUtZsnQ0lnZTWQz0VvetmV3kbSfDQWeo+7KetSk
 mJIcadChzvFdwNne28Y3JCVi4vE4RswsufTwiGUPXRj36ZFQfp2+ehTlnfu9LER9ENTCI0al9
 rZ2EarKhww65/GV1tvNACJDLE+Ea5CX5Z0nhu8jaX1TxvCeaE0L34bzVDYTnbEQDffEAJSsil
 LhmLSr/ZU34bf5y+yHHQYaTISxze/xXT7GUJ2d6BwONNzHfV7LPln2qZcx5w=
X-Spam-Score: -0.7 (/)
X-Debbugs-Envelope-To: 38136
Cc: Eric Abrahamsen <eric@HIDDEN>, Robert Pluim <rpluim@HIDDEN>,
 dick.r.chiang@HIDDEN, 38136 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.7 (-)

Lars Ingebrigtsen <larsi@HIDDEN> writes:

> That wouldn't be very difficult to add to debbugs-gnu, actually.  It
> already has the concept of "marked" bugs, so there could be a command
> like, say, `debbugs-gnu-show-marked' that just shows that list of bugs.

Patches welcome :-)

I'm not so fluid in writing gnus patches, so don't count on me.

Best regards, Michael.




Information forwarded to bug-gnu-emacs@HIDDEN, bugs@HIDDEN:
bug#38136; Package emacs,gnus. Full text available.

Message received at 38136 <at> debbugs.gnu.org:


Received: (at 38136) by debbugs.gnu.org; 20 Nov 2019 11:18:41 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Wed Nov 20 06:18:40 2019
Received: from localhost ([127.0.0.1]:49022 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1iXO0O-0007tf-Iu
	for submit <at> debbugs.gnu.org; Wed, 20 Nov 2019 06:18:40 -0500
Received: from quimby.gnus.org ([95.216.78.240]:40592)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <larsi@HIDDEN>) id 1iXO0M-0007tS-Re
 for 38136 <at> debbugs.gnu.org; Wed, 20 Nov 2019 06:18:39 -0500
Received: from cm-84.212.202.86.getinternet.no ([84.212.202.86] helo=marnie)
 by quimby.gnus.org with esmtpsa (TLS1.3:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.92) (envelope-from <larsi@HIDDEN>)
 id 1iXO0D-0006x2-6H; Wed, 20 Nov 2019 12:18:31 +0100
From: Lars Ingebrigtsen <larsi@HIDDEN>
To: Eric Abrahamsen <eric@HIDDEN>
Subject: Re: bug#38136: [PATCH] Make gnus-group-get-new-news a non blocking
 thread
References: <87imnu1knq.fsf@dick> <87r22h7mka.fsf@HIDDEN>
 <87sgmrouxk.fsf@HIDDEN> <8736emaxw6.fsf@HIDDEN>
 <87sgmlsgxx.fsf@HIDDEN> <87zhgsncno.fsf@HIDDEN>
 <87lfscesen.fsf@dick> <871ru4n58t.fsf@HIDDEN>
 <m21ru4p3t8.fsf@HIDDEN> <87ftijdcay.fsf@HIDDEN>
Date: Wed, 20 Nov 2019 12:18:28 +0100
In-Reply-To: <87ftijdcay.fsf@HIDDEN> (Eric Abrahamsen's message of
 "Tue, 19 Nov 2019 09:08:05 -0800")
Message-ID: <874kyykd8b.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/27.0.50 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain
X-Spam-Report: Spam detection software, running on the system "quimby.gnus.org",
 has NOT identified this incoming email as spam.  The original
 message has been attached to this so you can view it or label
 similar future email.  If you have any questions, see
 @@CONTACT_ADDRESS@@ for details.
 Content preview:  Eric Abrahamsen <eric@HIDDEN> writes: > Ha, I
 guess that's true, I've just never gotten accustomed to using > debbugs-gnu.
 I wish I could make a persistent debbugs view just showing > the few bugs
 I'm looking at at any given time (never v [...] 
 Content analysis details:   (-2.9 points, 5.0 required)
 pts rule name              description
 ---- ---------------------- --------------------------------------------------
 0.0 URIBL_BLOCKED          ADMINISTRATOR NOTICE: The query to URIBL was
 blocked.  See
 http://wiki.apache.org/spamassassin/DnsBlocklists#dnsbl-block
 for more information. [URIs: ingebrigtsen.no]
 -1.0 ALL_TRUSTED            Passed through trusted hosts only via SMTP
 -1.9 BAYES_00               BODY: Bayes spam probability is 0 to 1%
 [score: 0.0000]
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 38136
Cc: Robert Pluim <rpluim@HIDDEN>, dick.r.chiang@HIDDEN,
 38136 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

Eric Abrahamsen <eric@HIDDEN> writes:

> Ha, I guess that's true, I've just never gotten accustomed to using
> debbugs-gnu. I wish I could make a persistent debbugs view just showing
> the few bugs I'm looking at at any given time (never very many), which
> is easy to do in a Gnus group by ticking articles.

That wouldn't be very difficult to add to debbugs-gnu, actually.  It
already has the concept of "marked" bugs, so there could be a command
like, say, `debbugs-gnu-show-marked' that just shows that list of bugs.

-- 
(domestic pets only, the antidote for overdose, milk.)
   bloggy blog: http://lars.ingebrigtsen.no




Information forwarded to bug-gnu-emacs@HIDDEN, bugs@HIDDEN:
bug#38136; Package emacs,gnus. Full text available.

Message received at 38136 <at> debbugs.gnu.org:


Received: (at 38136) by debbugs.gnu.org; 19 Nov 2019 17:08:16 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Tue Nov 19 12:08:16 2019
Received: from localhost ([127.0.0.1]:48453 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1iX6z9-0003JC-No
	for submit <at> debbugs.gnu.org; Tue, 19 Nov 2019 12:08:16 -0500
Received: from ericabrahamsen.net ([52.70.2.18]:42088
 helo=mail.ericabrahamsen.net)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <eric@HIDDEN>) id 1iX6z7-0003Iz-8D
 for 38136 <at> debbugs.gnu.org; Tue, 19 Nov 2019 12:08:13 -0500
Received: from localhost (c-73-254-86-141.hsd1.wa.comcast.net [73.254.86.141])
 (Authenticated sender: eric@HIDDEN)
 by mail.ericabrahamsen.net (Postfix) with ESMTPSA id DB1CCFA01D;
 Tue, 19 Nov 2019 17:08:06 +0000 (UTC)
From: Eric Abrahamsen <eric@HIDDEN>
To: Robert Pluim <rpluim@HIDDEN>
Subject: Re: bug#38136: [PATCH] Make gnus-group-get-new-news a non blocking
 thread
References: <87imnu1knq.fsf@dick> <87r22h7mka.fsf@HIDDEN>
 <87sgmrouxk.fsf@HIDDEN> <8736emaxw6.fsf@HIDDEN>
 <87sgmlsgxx.fsf@HIDDEN> <87zhgsncno.fsf@HIDDEN>
 <87lfscesen.fsf@dick> <871ru4n58t.fsf@HIDDEN>
 <m21ru4p3t8.fsf@HIDDEN>
Date: Tue, 19 Nov 2019 09:08:05 -0800
In-Reply-To: <m21ru4p3t8.fsf@HIDDEN> (Robert Pluim's message of "Tue, 19
 Nov 2019 11:18:27 +0100")
Message-ID: <87ftijdcay.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/27.0.50 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 38136
Cc: Lars Ingebrigtsen <larsi@HIDDEN>, dick.r.chiang@HIDDEN,
 38136 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)


On 11/19/19 11:18 AM, Robert Pluim wrote:
>>>>>> On Mon, 18 Nov 2019 15:18:10 -0800, Eric Abrahamsen <eric@HIDDEN> said:
>
>     Eric> What I'd like is a Gnus summary minor mode I could enable in, say,
>     Eric> "emacs.bugs", which turns commit hashes into hyperlinks and provides
>     Eric> commands for "apply the attached patch to some worktree". I think other
>     Eric> people have done that, I've just never gotten around to it.
>
> You mean like 'debbugs-gnu' and 'debbugs-gnu-bugs' from the debbugs-gnu
> package? That has commands to do exactly that.

Ha, I guess that's true, I've just never gotten accustomed to using
debbugs-gnu. I wish I could make a persistent debbugs view just showing
the few bugs I'm looking at at any given time (never very many), which
is easy to do in a Gnus group by ticking articles.




Information forwarded to bug-gnu-emacs@HIDDEN, bugs@HIDDEN:
bug#38136; Package emacs,gnus. Full text available.

Message received at 38136 <at> debbugs.gnu.org:


Received: (at 38136) by debbugs.gnu.org; 19 Nov 2019 10:18:37 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Tue Nov 19 05:18:36 2019
Received: from localhost ([127.0.0.1]:46641 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1iX0ai-0008Li-MN
	for submit <at> debbugs.gnu.org; Tue, 19 Nov 2019 05:18:36 -0500
Received: from mail-wm1-f46.google.com ([209.85.128.46]:36602)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <rpluim@HIDDEN>) id 1iX0ag-0008LU-R1
 for 38136 <at> debbugs.gnu.org; Tue, 19 Nov 2019 05:18:35 -0500
Received: by mail-wm1-f46.google.com with SMTP id c22so2858411wmd.1
 for <38136 <at> debbugs.gnu.org>; Tue, 19 Nov 2019 02:18:34 -0800 (PST)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=gmail.com; s=20161025;
 h=from:to:cc:subject:references:gmane-reply-to-list:date:in-reply-to
 :message-id:mime-version;
 bh=V4MrGlHSmxsjHfP5VESEbeLETCyuEXEYO1ZpxEwzF6M=;
 b=A3jQD1Rh+RQV0AOl87gc2vYFNKsPxemowIRkw4E8S0rY60Gk+9gNbQW+XUnBIstcLH
 szP7D5cCu8tyZAsAgWxb78l8gZH2+S1zxYqlSsWECeR4k+jo9LXxVdhquRAKwpHM6ddc
 nsZmKkSKmFOd5WyoeREeA7y4GVZOjim+kKCFbFzKM7U1+FfFSrI81GxVAE2MD29btLwW
 N2IT11JIlADwj4MuzwgEzPRnS9Eqy9dzVmFl5erq5surEHNWiQu4/FtURwTAvogptvrv
 8SlvRMOUb9zItSLpogHM+DkglWO172sJdNcSC0m5OrAtRLIv+P0MA+30/4ZSmgPzh3fJ
 i1hg==
X-Google-DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=1e100.net; s=20161025;
 h=x-gm-message-state:from:to:cc:subject:references
 :gmane-reply-to-list:date:in-reply-to:message-id:mime-version;
 bh=V4MrGlHSmxsjHfP5VESEbeLETCyuEXEYO1ZpxEwzF6M=;
 b=PSHsj8xD66QbD83JIQRV899a1kUVENRE97mL6D5kGW5HAw+gHZe/+7lOWZrFdZDNsi
 ooT538tq06QL6F2iV51wAHcAM+CgKvi/skf9dEKzjTuWtGZDGC6d8YnbGHNSvrNkeEBU
 fkQUKTbZutEZMLlbwFUcZHvIfA2ZweylpHRQcetN/muWsrsSUp6u/A59RxkHmqYIUb2h
 ohSvzLpEzX2i4z1JzTTPqCpA4tQ3e/4NC2i0RGn7agVZUIdzF1YMqgH8/UKKF7gZb/qc
 EnJvOJ7D0q2MDeB57YBAC3S0JzUmDFoLdaU+bXtbvj3Mo/fxCiQ623hCmm3PPiq+D0T/
 oqSg==
X-Gm-Message-State: APjAAAVRQwVekozWJsFlXBgYNFagNT8cMl6Ye0RFtykLlM+8hmu9XUdu
 rQ9muBVbcCcA3OkgwZw/smIPGLwcNYo=
X-Google-Smtp-Source: APXvYqw0O9f/Yh4cw1uj6j651NAwjVA6TCVvRRXr3TG9Rt0gEc4Qgm5myqXtuPOjLmbf1442hPPK3Q==
X-Received: by 2002:a1c:5459:: with SMTP id p25mr4337776wmi.109.1574158708485; 
 Tue, 19 Nov 2019 02:18:28 -0800 (PST)
Received: from rpluim-mac ([149.5.228.1])
 by smtp.gmail.com with ESMTPSA id x5sm2581003wmj.7.2019.11.19.02.18.27
 (version=TLS1_3 cipher=TLS_AES_256_GCM_SHA384 bits=256/256);
 Tue, 19 Nov 2019 02:18:27 -0800 (PST)
From: Robert Pluim <rpluim@HIDDEN>
To: Eric Abrahamsen <eric@HIDDEN>
Subject: Re: bug#38136: [PATCH] Make gnus-group-get-new-news a non blocking
 thread
References: <87imnu1knq.fsf@dick> <87r22h7mka.fsf@HIDDEN>
 <87sgmrouxk.fsf@HIDDEN> <8736emaxw6.fsf@HIDDEN>
 <87sgmlsgxx.fsf@HIDDEN> <87zhgsncno.fsf@HIDDEN>
 <87lfscesen.fsf@dick> <871ru4n58t.fsf@HIDDEN>
X-Debbugs-No-Ack: yes
Gmane-Reply-To-List: yes
Date: Tue, 19 Nov 2019 11:18:27 +0100
In-Reply-To: <871ru4n58t.fsf@HIDDEN> (Eric Abrahamsen's message of
 "Mon, 18 Nov 2019 15:18:10 -0800")
Message-ID: <m21ru4p3t8.fsf@HIDDEN>
MIME-Version: 1.0
Content-Type: text/plain
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 38136
Cc: Lars Ingebrigtsen <larsi@HIDDEN>, dick.r.chiang@HIDDEN,
 38136 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

>>>>> On Mon, 18 Nov 2019 15:18:10 -0800, Eric Abrahamsen <eric@HIDDEN> said:

    Eric> What I'd like is a Gnus summary minor mode I could enable in, say,
    Eric> "emacs.bugs", which turns commit hashes into hyperlinks and provides
    Eric> commands for "apply the attached patch to some worktree". I think other
    Eric> people have done that, I've just never gotten around to it.

You mean like 'debbugs-gnu' and 'debbugs-gnu-bugs' from the debbugs-gnu
package? That has commands to do exactly that.

Robert




Information forwarded to bug-gnu-emacs@HIDDEN, bugs@HIDDEN:
bug#38136; Package emacs,gnus. Full text available.

Message received at 38136 <at> debbugs.gnu.org:


Received: (at 38136) by debbugs.gnu.org; 18 Nov 2019 23:18:22 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Mon Nov 18 18:18:22 2019
Received: from localhost ([127.0.0.1]:46427 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1iWqHl-0007Mr-VK
	for submit <at> debbugs.gnu.org; Mon, 18 Nov 2019 18:18:22 -0500
Received: from ericabrahamsen.net ([52.70.2.18]:46724
 helo=mail.ericabrahamsen.net)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <eric@HIDDEN>) id 1iWqHi-0007MY-95
 for 38136 <at> debbugs.gnu.org; Mon, 18 Nov 2019 18:18:19 -0500
Received: from localhost (c-73-254-86-141.hsd1.wa.comcast.net [73.254.86.141])
 (Authenticated sender: eric@HIDDEN)
 by mail.ericabrahamsen.net (Postfix) with ESMTPSA id E2322FA087;
 Mon, 18 Nov 2019 23:18:11 +0000 (UTC)
From: Eric Abrahamsen <eric@HIDDEN>
To: dick.r.chiang@HIDDEN
Subject: Re: bug#38136: [PATCH] Make gnus-group-get-new-news a non blocking
 thread
References: <87imnu1knq.fsf@dick> <87r22h7mka.fsf@HIDDEN>
 <87sgmrouxk.fsf@HIDDEN> <8736emaxw6.fsf@HIDDEN>
 <87sgmlsgxx.fsf@HIDDEN> <87zhgsncno.fsf@HIDDEN>
 <87lfscesen.fsf@dick>
Date: Mon, 18 Nov 2019 15:18:10 -0800
In-Reply-To: <87lfscesen.fsf@dick> (dick r. chiang's message of "Mon, 18 Nov
 2019 17:22:40 -0500")
Message-ID: <871ru4n58t.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/27.0.50 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 38136
Cc: Lars Ingebrigtsen <larsi@HIDDEN>, 38136 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)


On 11/18/19 17:22 PM, dick.r.chiang@HIDDEN wrote:
> I am very grateful for your interest and testing!

My pleasure, of course -- I think this is an important direction to be
going in.

>> selecting a deleted buffer
>
> I get this quite a bit.  It occurs when `gnus-summary-buffer` in the main
> thread gets usurped by a background thread.  I am either allowing this
> important variable to get reassigned before the dynamic-let in `gnus-thread-body`
> or I am not understanding dynamic-let in the presence of threads.
> Incidentally, it's very difficult to point to lines of code I'm talking
> about without git{hub,lab}.

We could consider turning on `lexical-binding' in gnus-start.el, and
just see what happens :)

Regarding code line numbers, etc, I just do it manually -- I'm looking
at the code to begin with, and it's trivial to check what line I'm on.

>> line 1791, because it's expecting "(car gnus-group-list-mode)" to be a
>> number, but it hasn't been set yet.
>
> I'll look into this, and add a test for `nntp-open-server`.
>
> I am happy to let this marinate to get people thinking about Gnus's
> future. There are many historical artifacts (like blocking
> `gnus-group-get-new-news`
> and left-field variables like `gnus-secondary-select-methods`) that prevent
> Gnus from becoming a viable MUA for more people.

Well they definitely prevent bug-hunters and feature-implementers from
making much progress. Stuff like `gnus-group-list-mode' drives me nuts:
an undocumented variable that might totally change Gnus' behavior. But
unpicking this complexity is slow work.

> Some other fellow recently posted about an ephemeral group branch which he
> somehow got others to test for him in-parallel.  I don't know how he did that
> outside the debbugs system.

I make liberal use of git worktrees. I made a local branch to apply your
patch, then checked it out into a separate directory with "git worktree
add" and built Emacs there. Then I run that Emacs. For Gnus stuff I have
a package called gnus-mock that provides a working Gnus environment with
dummy data. I point gnus-mock at the worktree directory, and it starts
up a clean Emacs with the Gnus data in place. I do most of my testing
there.

On the Emacs side it's projectile and magit: projectile indexes the
worktree as a separate project. If you send me a line number from your
branch to look at, I do "C-c p p" -> helm-projectile-switch-project
which opens up magit for the project, then "C-c p f" ->
helm-projectile-find-file, then the usual "M-g g" -> goto-line. Not too
inconvenient.

If you have access to the Emacs repos and are collaborating with others
who do, too, then it can make sense to push a "feature/foo" branch to
the repos, and share it. I've done testing that way.

What I'd like is a Gnus summary minor mode I could enable in, say,
"emacs.bugs", which turns commit hashes into hyperlinks and provides
commands for "apply the attached patch to some worktree". I think other
people have done that, I've just never gotten around to it.

Eric




Information forwarded to bug-gnu-emacs@HIDDEN, bugs@HIDDEN:
bug#38136; Package emacs,gnus. Full text available.

Message received at 38136 <at> debbugs.gnu.org:


Received: (at 38136) by debbugs.gnu.org; 18 Nov 2019 22:22:50 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Mon Nov 18 17:22:49 2019
Received: from localhost ([127.0.0.1]:46400 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1iWpQ1-00063x-MG
	for submit <at> debbugs.gnu.org; Mon, 18 Nov 2019 17:22:49 -0500
Received: from mail-qt1-f195.google.com ([209.85.160.195]:33576)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <dick.r.chiang@HIDDEN>) id 1iWpPz-00063j-Im
 for 38136 <at> debbugs.gnu.org; Mon, 18 Nov 2019 17:22:48 -0500
Received: by mail-qt1-f195.google.com with SMTP id y39so22234950qty.0
 for <38136 <at> debbugs.gnu.org>; Mon, 18 Nov 2019 14:22:47 -0800 (PST)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=gmail.com; s=20161025;
 h=from:to:cc:subject:references:date:in-reply-to:message-id
 :user-agent:mime-version;
 bh=1xduJx0D9nmNNKZ6b6z6kf28KFCKQsDvSbuGUk83G70=;
 b=m1YeYypCLOj1BxfFUk4IY7TIK70RsGWt+P72RKUlRXIwy0xlfa3XOKjJr2RLcqcp9B
 zeFdZS7Bf62VD4o6Essnybx5tTkFvW3pmIL8wj0T/nFGG/dnh3WxhQqBkfnQAEM/1BnU
 OJxzYWYchGlA3kPqx87HeZKlBWpJ9WPq5+QUhhKQK6NXhq1NIsnRmbExnSA/Tl4ZQY3M
 bN9MVY65aLr1fbAIAR+v4DQioa21SmbgnLdodxkB6SjObJHGisFHVmLg+iRZ9J9cYi8d
 aAZCk0GdCzYgwuDNgxBY14mMKbfliKmwFdAsMvxHcv7xlzaDMvj4PKloorj4ESvHn8yF
 Nf0A==
X-Google-DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=1e100.net; s=20161025;
 h=x-gm-message-state:from:to:cc:subject:references:date:in-reply-to
 :message-id:user-agent:mime-version;
 bh=1xduJx0D9nmNNKZ6b6z6kf28KFCKQsDvSbuGUk83G70=;
 b=jrHy0Bqj+NtLSxsxRthDYh5MI9S2DL2GjKWmGO2M2HhOCSyVvAclRBjUS0mS/D5eyS
 vMqAoh72X8BOKMdDvDDPuiefJAEhGM4oiV8/HPuKQ2lNbOEN2TsuMEcMP8cII4+fU7hh
 omNg6qLFg3xqrwBuAj9lTG7wwSyFsd0S0nQ3VDzXF4dhFC5sP+27Agk7P+Siz8vGHdBu
 xNBhAHfHuuQXRZz0Cb+Wkn+EAP4PWBnFY4PJ9zMUB65wixsS3+lxOgTE2ThcVTq9JgwX
 Sc8UIEBbnjwvEvVh+uLwL8ecWPIDg0c26AAcSH9wxnHBdrVHmzixvjTAIRsfnRXcY4q8
 Cl1g==
X-Gm-Message-State: APjAAAW1tJ+CjIcGNVXHYRx0lKfCbe9VBfPE5JGRGrXqGuxhlwyqmlA6
 ZNegZALazsfOpqrTJORPYsMmNdOZUh4=
X-Google-Smtp-Source: APXvYqxlbEi2Lf/6tkXJOSpwlpON2CJnWemnLWuhoxuBwac15Nq33+eY6AHIHKHzQmWDX6KuiHaYcg==
X-Received: by 2002:aed:34c6:: with SMTP id x64mr29141587qtd.324.1574115761951; 
 Mon, 18 Nov 2019 14:22:41 -0800 (PST)
Received: from localhost (pool-100-33-98-8.nycmny.fios.verizon.net.
 [100.33.98.8])
 by smtp.gmail.com with ESMTPSA id v20sm8993840qkg.92.2019.11.18.14.22.40
 (version=TLS1_2 cipher=ECDHE-RSA-AES128-GCM-SHA256 bits=128/128);
 Mon, 18 Nov 2019 14:22:41 -0800 (PST)
From: dick.r.chiang@HIDDEN
To: Eric Abrahamsen <eric@HIDDEN>
Subject: Re: bug#38136: [PATCH] Make gnus-group-get-new-news a non blocking
 thread
References: <87imnu1knq.fsf@dick> <87r22h7mka.fsf@HIDDEN>
 <87sgmrouxk.fsf@HIDDEN> <8736emaxw6.fsf@HIDDEN>
 <87sgmlsgxx.fsf@HIDDEN> <87zhgsncno.fsf@HIDDEN>
Date: Mon, 18 Nov 2019 17:22:40 -0500
In-Reply-To: <87zhgsncno.fsf@HIDDEN> (Eric Abrahamsen's message of
 "Mon, 18 Nov 2019 12:38:03 -0800")
Message-ID: <87lfscesen.fsf@dick>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/27.0.50 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 38136
Cc: Lars Ingebrigtsen <larsi@HIDDEN>, 38136 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

I am very grateful for your interest and testing!

> selecting a deleted buffer

I get this quite a bit.  It occurs when `gnus-summary-buffer` in the main
thread gets usurped by a background thread.  I am either allowing this
important variable to get reassigned before the dynamic-let in `gnus-thread-body`
or I am not understanding dynamic-let in the presence of threads.
Incidentally, it's very difficult to point to lines of code I'm talking
about without git{hub,lab}.

> line 1791, because it's expecting "(car gnus-group-list-mode)" to be a
> number, but it hasn't been set yet.

I'll look into this, and add a test for `nntp-open-server`.

I am happy to let this marinate to get people thinking about Gnus's future.  There are many historical artifacts (like blocking `gnus-group-get-new-news`
and left-field variables like `gnus-secondary-select-methods`) that prevent
Gnus from becoming a viable MUA for more people.

Some other fellow recently posted about an ephemeral group branch which he
somehow got others to test for him in-parallel.  I don't know how he did that
outside the debbugs system.





Information forwarded to bug-gnu-emacs@HIDDEN, bugs@HIDDEN:
bug#38136; Package emacs,gnus. Full text available.

Message received at 38136 <at> debbugs.gnu.org:


Received: (at 38136) by debbugs.gnu.org; 18 Nov 2019 20:38:18 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Mon Nov 18 15:38:18 2019
Received: from localhost ([127.0.0.1]:46326 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1iWnmr-0003TN-SH
	for submit <at> debbugs.gnu.org; Mon, 18 Nov 2019 15:38:18 -0500
Received: from ericabrahamsen.net ([52.70.2.18]:43086
 helo=mail.ericabrahamsen.net)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <eric@HIDDEN>) id 1iWnmq-0003TA-93
 for 38136 <at> debbugs.gnu.org; Mon, 18 Nov 2019 15:38:16 -0500
Received: from localhost (unknown [205.175.106.77])
 (Authenticated sender: eric@HIDDEN)
 by mail.ericabrahamsen.net (Postfix) with ESMTPSA id 00D56FA087;
 Mon, 18 Nov 2019 20:38:09 +0000 (UTC)
From: Eric Abrahamsen <eric@HIDDEN>
To: Lars Ingebrigtsen <larsi@HIDDEN>
Subject: Re: bug#38136: [PATCH] Make gnus-group-get-new-news a non blocking
 thread
References: <87imnu1knq.fsf@dick> <87r22h7mka.fsf@HIDDEN>
 <87sgmrouxk.fsf@HIDDEN> <8736emaxw6.fsf@HIDDEN>
 <87sgmlsgxx.fsf@HIDDEN>
Date: Mon, 18 Nov 2019 12:38:03 -0800
Message-ID: <87zhgsncno.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/27.0.50 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 38136
Cc: dick.r.chiang@HIDDEN, 38136 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)


On 11/18/19 09:54 AM, Lars Ingebrigtsen wrote:
> Eric Abrahamsen <eric@HIDDEN> writes:
>
>> I haven't tried to make it raise an error, but I did set
>> `nntp-connection-timeout' very low, and try to trigger an error that
>> way. Nothing bad happened -- I will take a look at the code and see how
>> timeouts are handled.
>
> Try putting an (error) in `nntp-open-server' or something.  :-)

Oh, sure. I stuck errors in `nntp-open-server' and
`nntp-finish-retrieve-group-infos', and worked that both with a
nntp-connection-timeout and without, and wasn't able to drive it
completely off the rails -- unfortunately I did get two odd errors which
I was later unable to reproduce: one about selecting a deleted buffer,
which I think came out of `nntp-open-server', and another that looked
like "gnus-thread-group: " and then a chunk of bytecode. I don't know
how I got those, though!

The only other error I'm seeing now is if you start Gnus at a specified
level (ie "M-4 M-x gnus"), it will error out in
`gnus-get-unread-articles', line 1791, because it's expecting "(car
gnus-group-list-mode)" to be a number, but it hasn't been set yet.

In general, it would be great to have more code comments, particularly
in `gnus-get-unread-articles'. I'm afraid that we're going to end up
with more code that only one person really understands, touching on an
area of elisp (threading) that we're all kind of expecting to be
unstable.

That's all I've got for now.




Information forwarded to bug-gnu-emacs@HIDDEN, bugs@HIDDEN:
bug#38136; Package emacs,gnus. Full text available.

Message received at 38136 <at> debbugs.gnu.org:


Received: (at 38136) by debbugs.gnu.org; 18 Nov 2019 08:54:32 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Mon Nov 18 03:54:31 2019
Received: from localhost ([127.0.0.1]:43128 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1iWcnn-0001gF-JI
	for submit <at> debbugs.gnu.org; Mon, 18 Nov 2019 03:54:31 -0500
Received: from quimby.gnus.org ([95.216.78.240]:32822)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <larsi@HIDDEN>) id 1iWcnl-0001g1-2K
 for 38136 <at> debbugs.gnu.org; Mon, 18 Nov 2019 03:54:29 -0500
Received: from cm-84.212.202.86.getinternet.no ([84.212.202.86] helo=marnie)
 by quimby.gnus.org with esmtpsa (TLS1.3:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.92) (envelope-from <larsi@HIDDEN>)
 id 1iWcnb-0007NZ-AI; Mon, 18 Nov 2019 09:54:21 +0100
From: Lars Ingebrigtsen <larsi@HIDDEN>
To: Eric Abrahamsen <eric@HIDDEN>
Subject: Re: bug#38136: [PATCH] Make gnus-group-get-new-news a non blocking
 thread
References: <87imnu1knq.fsf@dick> <87r22h7mka.fsf@HIDDEN>
 <87sgmrouxk.fsf@HIDDEN> <8736emaxw6.fsf@HIDDEN>
Date: Mon, 18 Nov 2019 09:54:18 +0100
In-Reply-To: <8736emaxw6.fsf@HIDDEN> (Eric Abrahamsen's message of
 "Sun, 17 Nov 2019 15:25:29 -0800")
Message-ID: <87sgmlsgxx.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/27.0.50 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain
X-Spam-Report: Spam detection software, running on the system "quimby.gnus.org",
 has NOT identified this incoming email as spam.  The original
 message has been attached to this so you can view it or label
 similar future email.  If you have any questions, see
 @@CONTACT_ADDRESS@@ for details.
 Content preview: Eric Abrahamsen <eric@HIDDEN> writes: > I haven't
 tried to make it raise an error, but I did set > `nntp-connection-timeout'
 very low, and try to trigger an error that > way. Nothing bad happened --
 I will take a look at the code and see [...] 
 Content analysis details:   (-2.9 points, 5.0 required)
 pts rule name              description
 ---- ---------------------- --------------------------------------------------
 0.0 URIBL_BLOCKED          ADMINISTRATOR NOTICE: The query to URIBL was
 blocked.  See
 http://wiki.apache.org/spamassassin/DnsBlocklists#dnsbl-block
 for more information. [URIs: ingebrigtsen.no]
 -1.0 ALL_TRUSTED            Passed through trusted hosts only via SMTP
 -1.9 BAYES_00               BODY: Bayes spam probability is 0 to 1%
 [score: 0.0000]
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 38136
Cc: dick.r.chiang@HIDDEN, 38136 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

Eric Abrahamsen <eric@HIDDEN> writes:

> I haven't tried to make it raise an error, but I did set
> `nntp-connection-timeout' very low, and try to trigger an error that
> way. Nothing bad happened -- I will take a look at the code and see how
> timeouts are handled.

Try putting an (error) in `nntp-open-server' or something.  :-)

> So far so good!

Sounds good.

-- 
(domestic pets only, the antidote for overdose, milk.)
   bloggy blog: http://lars.ingebrigtsen.no




Information forwarded to bug-gnu-emacs@HIDDEN, bugs@HIDDEN:
bug#38136; Package emacs,gnus. Full text available.

Message received at 38136 <at> debbugs.gnu.org:


Received: (at 38136) by debbugs.gnu.org; 17 Nov 2019 23:25:38 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sun Nov 17 18:25:38 2019
Received: from localhost ([127.0.0.1]:42922 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1iWTvG-000769-Cp
	for submit <at> debbugs.gnu.org; Sun, 17 Nov 2019 18:25:38 -0500
Received: from ericabrahamsen.net ([52.70.2.18]:43014
 helo=mail.ericabrahamsen.net)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <eric@HIDDEN>) id 1iWTvE-00075x-OT
 for 38136 <at> debbugs.gnu.org; Sun, 17 Nov 2019 18:25:37 -0500
Received: from localhost (unknown [205.175.106.140])
 (Authenticated sender: eric@HIDDEN)
 by mail.ericabrahamsen.net (Postfix) with ESMTPSA id C15FCFA01D;
 Sun, 17 Nov 2019 23:25:30 +0000 (UTC)
From: Eric Abrahamsen <eric@HIDDEN>
To: Lars Ingebrigtsen <larsi@HIDDEN>
Subject: Re: bug#38136: [PATCH] Make gnus-group-get-new-news a non blocking
 thread
References: <87imnu1knq.fsf@dick> <87r22h7mka.fsf@HIDDEN>
 <87sgmrouxk.fsf@HIDDEN>
Date: Sun, 17 Nov 2019 15:25:29 -0800
In-Reply-To: <87sgmrouxk.fsf@HIDDEN> (Lars Ingebrigtsen's message of "Thu,
 14 Nov 2019 07:04:23 +0100")
Message-ID: <8736emaxw6.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/27.0.50 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 38136
Cc: dick.r.chiang@HIDDEN, 38136 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

Lars Ingebrigtsen <larsi@HIDDEN> writes:

> Eric Abrahamsen <eric@HIDDEN> writes:
>
>> dick.r.chiang@HIDDEN writes:
>>
>>> From 834327d458c54bb0e1f25c6259ee640df0ba8b0e Mon Sep 17 00:00:00 2001
>>> From: dickmao <none>
>>> Date: Fri, 8 Nov 2019 09:51:59 -0500
>>> Subject: [PATCH] Make `gnus-group-get-new-news` a non-blocking thread
>>
>> I'm looking forward to testing this out this weekend!

I finally got to road-testing this, and so far haven't been able to
break it.

> It'd be helpful if you wrote something about how errors during `g' are
> reported and stuff and how stable this is, because my impression of the
> Emacs thread support is that it is (so far) got some stability
> problems.  

I haven't tried to make it raise an error, but I did set
`nntp-connection-timeout' very low, and try to trigger an error that
way. Nothing bad happened -- I will take a look at the code and see how
timeouts are handled.

So far so good!




Information forwarded to bug-gnu-emacs@HIDDEN, bugs@HIDDEN:
bug#38136; Package emacs,gnus. Full text available.

Message received at 38136 <at> debbugs.gnu.org:


Received: (at 38136) by debbugs.gnu.org; 14 Nov 2019 06:04:34 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Thu Nov 14 01:04:34 2019
Received: from localhost ([127.0.0.1]:60720 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1iV8F7-0004jw-NS
	for submit <at> debbugs.gnu.org; Thu, 14 Nov 2019 01:04:33 -0500
Received: from quimby.gnus.org ([95.216.78.240]:49872)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <larsi@HIDDEN>) id 1iV8F6-0004jj-EG
 for 38136 <at> debbugs.gnu.org; Thu, 14 Nov 2019 01:04:32 -0500
Received: from cm-84.212.202.86.getinternet.no ([84.212.202.86] helo=marnie)
 by quimby.gnus.org with esmtpsa (TLS1.3:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.92) (envelope-from <larsi@HIDDEN>)
 id 1iV8Ey-0000s6-HN; Thu, 14 Nov 2019 07:04:26 +0100
From: Lars Ingebrigtsen <larsi@HIDDEN>
To: Eric Abrahamsen <eric@HIDDEN>
Subject: Re: bug#38136: [PATCH] Make gnus-group-get-new-news a non blocking
 thread
References: <87imnu1knq.fsf@dick> <87r22h7mka.fsf@HIDDEN>
Date: Thu, 14 Nov 2019 07:04:23 +0100
In-Reply-To: <87r22h7mka.fsf@HIDDEN> (Eric Abrahamsen's message of
 "Fri, 08 Nov 2019 19:31:17 -0800")
Message-ID: <87sgmrouxk.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/27.0.50 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain
X-Spam-Report: Spam detection software, running on the system "quimby.gnus.org",
 has NOT identified this incoming email as spam.  The original
 message has been attached to this so you can view it or label
 similar future email.  If you have any questions, see
 @@CONTACT_ADDRESS@@ for details.
 Content preview: Eric Abrahamsen <eric@HIDDEN> writes: >
 dick.r.chiang@HIDDEN
 writes: > >> From 834327d458c54bb0e1f25c6259ee640df0ba8b0e Mon Sep 17 00:00:00
 2001 >> From: dickmao <none> >> Date: Fri,
 8 Nov 2019 09:51:59 -0500 >> Subject: [PATCH] Make ` [...] 
 Content analysis details:   (-1.0 points, 5.0 required)
 pts rule name              description
 ---- ---------------------- --------------------------------------------------
 0.0 URIBL_BLOCKED          ADMINISTRATOR NOTICE: The query to URIBL was
 blocked.  See
 http://wiki.apache.org/spamassassin/DnsBlocklists#dnsbl-block
 for more information. [URIs: ingebrigtsen.no]
 -1.0 ALL_TRUSTED            Passed through trusted hosts only via SMTP
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 38136
Cc: dick.r.chiang@HIDDEN, 38136 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

Eric Abrahamsen <eric@HIDDEN> writes:

> dick.r.chiang@HIDDEN writes:
>
>> From 834327d458c54bb0e1f25c6259ee640df0ba8b0e Mon Sep 17 00:00:00 2001
>> From: dickmao <none>
>> Date: Fri, 8 Nov 2019 09:51:59 -0500
>> Subject: [PATCH] Make `gnus-group-get-new-news` a non-blocking thread
>
> I'm looking forward to testing this out this weekend!

I haven't tested it, but it sounds like a great feature.

> Just a quick NB, which you should feel free to ignore: you'll probably
> get much better uptake on these tickets if you include with them a
> head-to-toe prose report on what they accomplish and why (in detail).
> Emacs has a lot of bug reports, and a small number of bug hunters, and a
> multi-hundred-line patch without so much as a "howdy-do" on it is ripe
> to be ignored. Just something to consider.

No, please don't ignore.  :-)

It'd be helpful if you wrote something about how errors during `g' are
reported and stuff and how stable this is, because my impression of the
Emacs thread support is that it is (so far) got some stability
problems.  

-- 
(domestic pets only, the antidote for overdose, milk.)
   bloggy blog: http://lars.ingebrigtsen.no




Information forwarded to bug-gnu-emacs@HIDDEN, bugs@HIDDEN:
bug#38136; Package emacs,gnus. Full text available.

Message received at 38136 <at> debbugs.gnu.org:


Received: (at 38136) by debbugs.gnu.org; 12 Nov 2019 10:01:22 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Tue Nov 12 05:01:22 2019
Received: from localhost ([127.0.0.1]:56336 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1iUSzC-0008RU-1y
	for submit <at> debbugs.gnu.org; Tue, 12 Nov 2019 05:01:22 -0500
Received: from mail-wr1-f68.google.com ([209.85.221.68]:34910)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <rpluim@HIDDEN>) id 1iUSz7-0008R6-UD
 for 38136 <at> debbugs.gnu.org; Tue, 12 Nov 2019 05:01:18 -0500
Received: by mail-wr1-f68.google.com with SMTP id s5so6684713wrw.2
 for <38136 <at> debbugs.gnu.org>; Tue, 12 Nov 2019 02:01:17 -0800 (PST)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=gmail.com; s=20161025;
 h=from:to:cc:subject:references:gmane-reply-to-list:date:in-reply-to
 :message-id:mime-version;
 bh=W5jBM5g8K1h7bz8i3hIGS10m27Fuz9TUanBp4DYwBAc=;
 b=ASHFxH9vI3nG1T6W7y+bCpoylC9Tt2sVmlVbHbBAar6C0svtqNGOmWk/JW/EgItfeN
 mMi2zV2VmHbWm4hqCCoJYzJXT3Blxgwacn7+TYWXJIPiuoT1GVeElOnvQX0S0KdEYHzy
 UM3NiQznL0+0a7xTN7p9dlv71BcMUm0Y3Ist1sRmqVboBKW0YQjKggfIk4SZzeN76Ela
 QYMrEUZESZo1MGW+c0nq8jza+2EAxpDXcxGfPti5vfmgl+s8BFIT8QXgjsKOmP/5rwFZ
 LqUMnITMDW0EPm2oXNIThbuupnQoF2btTJibNRLy8b9LmxfdkOVnZVpLdevj2sqk2O3k
 Krug==
X-Google-DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=1e100.net; s=20161025;
 h=x-gm-message-state:from:to:cc:subject:references
 :gmane-reply-to-list:date:in-reply-to:message-id:mime-version;
 bh=W5jBM5g8K1h7bz8i3hIGS10m27Fuz9TUanBp4DYwBAc=;
 b=nK1h1Rp/M3GIR3uMr2Ei+LrhUKYTd3MD22SMMOvyLzOSwHzztLMjXEzH1UB5eEJBlc
 upOscqnL1g1sfq3xnNpOlY2QTFxY8sVAJe3TFq/AvSm6giAivM32VLDBKAmUzoeEcCZb
 hgM48M1YLFptOmSZu1GOafpagxE+iaeiSHQWqwz5cJyM8e29/jDYsgDISyjNVXM7I5EN
 Q4vJNpQAndf9GL1cEuFQPQDev3rCy+Q0oojM642tN3q3alAMilFU/+HHCrAl9MuZNhHx
 oxztg2uTFMiM1kfBqUpdgK23K7d6t3x3440LDiSRD4XnKZk4v1HEL0P7mvoPA4jS73fF
 mbSA==
X-Gm-Message-State: APjAAAVePY81AR+9/q/fYhgTPQmRZeSJ6gWDH0xitETJaLZwOd2BWrYG
 3+5ALC0r713DrGrwOD6kTNJEgEpl
X-Google-Smtp-Source: APXvYqxBCSffwXpMaZgkh81qNmQIUC4FTX5Dncp+JDJPudp7CiGgO22bXYAz3H8CdFzP42mzy9JlmQ==
X-Received: by 2002:adf:9323:: with SMTP id 32mr24459280wro.15.1573552870819; 
 Tue, 12 Nov 2019 02:01:10 -0800 (PST)
Received: from rpluim-mac ([149.5.228.1])
 by smtp.gmail.com with ESMTPSA id j66sm1896259wma.19.2019.11.12.02.01.09
 (version=TLS1_3 cipher=TLS_AES_256_GCM_SHA384 bits=256/256);
 Tue, 12 Nov 2019 02:01:10 -0800 (PST)
From: Robert Pluim <rpluim@HIDDEN>
To: dick.r.chiang@HIDDEN
Subject: Re: bug#38136: [PATCH] Make gnus-group-get-new-news a non blocking
 thread, bug#38136: [PATCH] Make gnus-group-get-new-news a non blocking
 thread
References: <87imnu1knq.fsf@dick> <87imnu1knq.fsf@dick>
X-Debbugs-No-Ack: yes
Gmane-Reply-To-List: yes
Date: Tue, 12 Nov 2019 11:01:08 +0100
In-Reply-To: <87imnu1knq.fsf@dick> (dick r. chiang's message of "Fri, 08 Nov
 2019 09:56:41 -0500, Fri, 08 Nov 2019 19:31:17 -0800")
Message-ID: <m2d0dxbehn.fsf@HIDDEN>
MIME-Version: 1.0
Content-Type: text/plain
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 38136
Cc: Eric Abrahamsen <eric@HIDDEN>, 38136 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

>>>>> On Fri, 08 Nov 2019 19:31:17 -0800, Eric Abrahamsen <eric@HIDDEN> said:

    Eric> dick.r.chiang@HIDDEN writes:

    >> From 834327d458c54bb0e1f25c6259ee640df0ba8b0e Mon Sep 17 00:00:00 2001
    >> From: dickmao <none>
    >> Date: Fri, 8 Nov 2019 09:51:59 -0500
    >> Subject: [PATCH] Make `gnus-group-get-new-news` a non-blocking thread

    Eric> I'm looking forward to testing this out this weekend!

    Eric> Just a quick NB, which you should feel free to ignore: you'll probably
    Eric> get much better uptake on these tickets if you include with them a
    Eric> head-to-toe prose report on what they accomplish and why (in detail).
    Eric> Emacs has a lot of bug reports, and a small number of bug hunters, and a
    Eric> multi-hundred-line patch without so much as a "howdy-do" on it is ripe
    Eric> to be ignored. Just something to consider.

That, plus the patch has spurious whitspace changes, and things like
the below, which makes it all harder to read.

>>>>> On Fri, 08 Nov 2019 09:56:41 -0500, dick.r.chiang@HIDDEN said:
    dick> diff --git a/src/fns.c b/src/fns.c
    dick> index cbb6879223..7d4ed7cab6 100644
    dick> --- a/src/fns.c
    dick> +++ b/src/fns.c
    dick> @@ -2917,8 +2917,7 @@ require_unwind (Lisp_Object old_value)
 
    dick>  DEFUN ("require", Frequire, Srequire, 1, 3, 0,
    dick>         doc: /* If feature FEATURE is not loaded, load it from FILENAME.
    dick> -If FEATURE is not a member of the list `features', then the feature is
    dick> -not loaded; so load the file FILENAME.
    dick> +Loaded features are recorded in the list variable `features'.
 
    dick>  If FILENAME is omitted, the printname of FEATURE is used as the file
    dick>  name, and `load' will try to load this name appended with the suffix
    dick> -- 
    dick> 2.23.0




Information forwarded to bug-gnu-emacs@HIDDEN, bugs@HIDDEN:
bug#38136; Package emacs,gnus. Full text available.

Message received at 38136 <at> debbugs.gnu.org:


Received: (at 38136) by debbugs.gnu.org; 9 Nov 2019 03:33:51 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Fri Nov 08 22:33:51 2019
Received: from localhost ([127.0.0.1]:48044 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1iTHVW-0006UP-NR
	for submit <at> debbugs.gnu.org; Fri, 08 Nov 2019 22:33:50 -0500
Received: from ericabrahamsen.net ([52.70.2.18]:39832
 helo=mail.ericabrahamsen.net)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <eric@HIDDEN>) id 1iTHVV-0006UC-2F
 for 38136 <at> debbugs.gnu.org; Fri, 08 Nov 2019 22:33:49 -0500
Received: from localhost (unknown [172.58.45.25])
 (Authenticated sender: eric@HIDDEN)
 by mail.ericabrahamsen.net (Postfix) with ESMTPSA id F1A6AFA092;
 Sat,  9 Nov 2019 03:33:40 +0000 (UTC)
From: Eric Abrahamsen <eric@HIDDEN>
To: dick.r.chiang@HIDDEN
Subject: Re: bug#38136: [PATCH] Make gnus-group-get-new-news a non blocking
 thread
In-Reply-To: <87imnu1knq.fsf@dick> (dick r. chiang's message of "Fri, 08 Nov
 2019 09:56:41 -0500")
Date: Fri, 08 Nov 2019 19:31:17 -0800
Message-ID: <87r22h7mka.fsf@HIDDEN>
References: <87imnu1knq.fsf@dick>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/27.0.50 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 38136
Cc: 38136 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

dick.r.chiang@HIDDEN writes:

> From 834327d458c54bb0e1f25c6259ee640df0ba8b0e Mon Sep 17 00:00:00 2001
> From: dickmao <none>
> Date: Fri, 8 Nov 2019 09:51:59 -0500
> Subject: [PATCH] Make `gnus-group-get-new-news` a non-blocking thread

I'm looking forward to testing this out this weekend!

Just a quick NB, which you should feel free to ignore: you'll probably
get much better uptake on these tickets if you include with them a
head-to-toe prose report on what they accomplish and why (in detail).
Emacs has a lot of bug reports, and a small number of bug hunters, and a
multi-hundred-line patch without so much as a "howdy-do" on it is ripe
to be ignored. Just something to consider.




Information forwarded to bug-gnu-emacs@HIDDEN, bugs@HIDDEN:
bug#38136; Package emacs,gnus. Full text available.
bug reassigned from package 'emacs' to 'emacs,gnus'. Request was from dick <dick.r.chiang@HIDDEN> to control <at> debbugs.gnu.org. Full text available.

Message received at submit <at> debbugs.gnu.org:


Received: (at submit) by debbugs.gnu.org; 8 Nov 2019 14:56:58 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Fri Nov 08 09:56:58 2019
Received: from localhost ([127.0.0.1]:47434 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1iT5h3-0004HD-5W
	for submit <at> debbugs.gnu.org; Fri, 08 Nov 2019 09:56:58 -0500
Received: from lists.gnu.org ([209.51.188.17]:43653)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <dick.r.chiang@HIDDEN>) id 1iT5gy-0004H7-7Z
 for submit <at> debbugs.gnu.org; Fri, 08 Nov 2019 09:56:53 -0500
Received: from eggs.gnu.org ([2001:470:142:3::10]:45087)
 by lists.gnu.org with esmtp (Exim 4.90_1)
 (envelope-from <dick.r.chiang@HIDDEN>) id 1iT5gu-0001Pd-TK
 for bug-gnu-emacs@HIDDEN; Fri, 08 Nov 2019 09:56:51 -0500
X-Spam-Checker-Version: SpamAssassin 3.3.2 (2011-06-06) on eggs.gnu.org
X-Spam-Level: 
X-Spam-Status: No, score=0.8 required=5.0 tests=BAYES_50,FREEMAIL_FROM
 autolearn=disabled version=3.3.2
Received: from Debian-exim by eggs.gnu.org with spam-scanned (Exim 4.71)
 (envelope-from <dick.r.chiang@HIDDEN>) id 1iT5gs-00005p-0V
 for bug-gnu-emacs@HIDDEN; Fri, 08 Nov 2019 09:56:48 -0500
Received: from mail-qk1-x72e.google.com ([2607:f8b0:4864:20::72e]:43067)
 by eggs.gnu.org with esmtps (TLS1.0:RSA_AES_128_CBC_SHA1:16)
 (Exim 4.71) (envelope-from <dick.r.chiang@HIDDEN>)
 id 1iT5gr-00005X-PV
 for bug-gnu-emacs@HIDDEN; Fri, 08 Nov 2019 09:56:45 -0500
Received: by mail-qk1-x72e.google.com with SMTP id z23so5456406qkj.10
 for <bug-gnu-emacs@HIDDEN>; Fri, 08 Nov 2019 06:56:45 -0800 (PST)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=gmail.com; s=20161025;
 h=from:to:subject:date:message-id:user-agent:mime-version
 :content-disposition:content-description;
 bh=y3nMsOZdJriUbjvlsitm6rqHawmQdgjQ1YRb43Sgg7k=;
 b=r99c9mG+ofTzMKEdV7D/YwiLatou5H2QLjc+OarWrO+grr28UgitFGaWxoZpclKgnN
 svpH5+/BWCr1SXHw+LVsK1UISX+xo49AdaaTsqP4PswqddE1vO882yiRfNEA2XMFjNCE
 j0FVHZBoF9Izx212QeVpCwytmooUnLg+2NjmEOYk60zAl2tURYpxhqCMLALXuE3Bk2Es
 4b3iubj5dOrYwa9iYP/FDJAdk8KUQsuMHh/zMvH3+174RrI+rnBZYJpVfRWXpej2huAn
 upYlqZl7XXe9ek0mNdw1A4Glrq8muZNIRGjIiUftk/3OK1ylmd0NMhVhlFFcNNs0gTnE
 D+4A==
X-Google-DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=1e100.net; s=20161025;
 h=x-gm-message-state:from:to:subject:date:message-id:user-agent
 :mime-version:content-disposition:content-description;
 bh=y3nMsOZdJriUbjvlsitm6rqHawmQdgjQ1YRb43Sgg7k=;
 b=iv1x8AX0gChdKvgk78gNNh8KKqKl8CXNVGZmxbkK2MbYQ1PbEkDySIdxLGPbs6V6RI
 o0th4vjdeBAXPozw3k5U8otmnQeZZpGRiIFMYyPvJSO0uDfk7JLxSnKUAf6xr/QDiqd4
 zcN9F5L9AJBI0gLzIb5j93hSJhF5pfgFFSVw5ay/VbcktsgBuZgL/WP6PE56qmLMw7O/
 PqfH18jaq6SmWQmg2t1b/DUd7UaybY6V5DfyBS2n/zfTzYr5sIU9YvilGee+2UiuvTAL
 mML1iubY2TjeXH72LF/x4WXNNUmLaHZrQXQDe+dp//JwJzLNOlZ2q4lWKc2TsDfoDMFx
 WcrA==
X-Gm-Message-State: APjAAAV2pJYAjZ8JcynD3ChmGEqJWovzTfmKSWDfHG8K1uiHdFYmWgLo
 XruJeSWl+jZyNz45z0SICeSyPiwd
X-Google-Smtp-Source: APXvYqyuWQcSB1Xb3wWYqz6LHlNCDYo8j5Mn3+1TsgPW7JT4gSLGBhy8g46Hoogh3YuPKTRhqVS9kQ==
X-Received: by 2002:a05:620a:208a:: with SMTP id
 e10mr8704883qka.221.1573225004381; 
 Fri, 08 Nov 2019 06:56:44 -0800 (PST)
Received: from localhost (pool-100-33-98-8.nycmny.fios.verizon.net.
 [100.33.98.8])
 by smtp.gmail.com with ESMTPSA id n49sm3361264qtk.94.2019.11.08.06.56.42
 (version=TLS1_2 cipher=ECDHE-RSA-AES128-GCM-SHA256 bits=128/128);
 Fri, 08 Nov 2019 06:56:42 -0800 (PST)
From: dick.r.chiang@HIDDEN
To: bug-gnu-emacs <bug-gnu-emacs@HIDDEN>
Subject: [PATCH] Make gnus-group-get-new-news a non blocking thread
Date: Fri, 08 Nov 2019 09:56:41 -0500
Message-ID: <87imnu1knq.fsf@dick>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/27.0.50 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/x-diff
Content-Disposition: inline;
 filename=0001-Make-gnus-group-get-new-news-a-non-blocking-thread.patch
Content-Description: patch
X-detected-operating-system: by eggs.gnu.org: Genre and OS details not
 recognized.
X-Received-From: 2607:f8b0:4864:20::72e
X-Spam-Score: 0.7 (/)
X-Debbugs-Envelope-To: submit
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -2.3 (--)

From 834327d458c54bb0e1f25c6259ee640df0ba8b0e Mon Sep 17 00:00:00 2001
From: dickmao <none>
Date: Fri, 8 Nov 2019 09:51:59 -0500
Subject: [PATCH] Make `gnus-group-get-new-news` a non-blocking thread

* lisp/gnus/gnus-demon.el (gnus-demon-scan-news):
Add threaded optional argument.
* lisp/gnus/gnus-group.el (gnus-group-get-new-news):
Add threaded optional argument.
(gnus-threaded-get-unread-articles): This defcustom activates threading.
It defaults to nil.
(gnus-1): Add threaded optional argument.
(gnus-instantiate-server-buffer):
Make a new nntp-server-buffer for each thread.
(gnus-get-unread-articles-pass-preceding):
Tack preceding return value to ARGS before applying F.
(gnus-thread-body):
Let-close gnus global variables, create private nntp-server-buffer,
run the threaded function, and kill the nntp-server-buffer.
(gnus-run-thread): Make the thread.  Populate with serially dependent
sequence of functions.
(gnus-mutex-get-unread-articles):
Getting unread articles is a criticial section.
(gnus-get-unread-articles):
Reorder for threading.
(gnus-read-active-for-groups): Reprosecute tabs versus spaces.
(gnus-read-active-file-1): Elide a logical redundancy.
* lisp/gnus/gnus-sum.el (gnus-summary-display-article):
Replace if-null with when.
* lisp/gnus/gnus-util.el (gnus-push-end):
Define a convenience macro.
* lisp/gnus/nnheader.el
(nnheader-init-server-buffer, nnheader-prep-server-buffer):
Refactor "setting the table" in `nnheader-init-server-buffer`.
* lisp/gnus/nnimap.el (nnimap-make-process-buffer):
Apply due diligence if user kills nnimap process buffer.
* lisp/gnus/nntp.el (nntp-open-connection):
Apply due diligence if user kills nntp process buffer.
* lisp/mh-e/mh-compat.el (defun):
Reword an ancient and very confusing sentence.
* src/fns.c (Frequire):
Reword an ancient and very confusing sentence.
---
 etc/gnus/news-server.ast |   2 +-
 lisp/gnus/gnus-demon.el  |   3 +-
 lisp/gnus/gnus-group.el  |  14 +-
 lisp/gnus/gnus-start.el  | 289 ++++++++++++++++++++++++++++-----------
 lisp/gnus/gnus-sum.el    |   3 +-
 lisp/gnus/gnus-util.el   |   3 +
 lisp/gnus/nnheader.el    |  15 +-
 lisp/gnus/nnimap.el      |  13 ++
 lisp/gnus/nntp.el        |  13 ++
 lisp/mh-e/mh-compat.el   |   3 +-
 src/fns.c                |   3 +-
 11 files changed, 257 insertions(+), 104 deletions(-)

diff --git a/etc/gnus/news-server.ast b/etc/gnus/news-server.ast
index df0bab4519..555ac47cd9 100644
--- a/etc/gnus/news-server.ast
+++ b/etc/gnus/news-server.ast
@@ -20,7 +20,7 @@ Port number: @variable{port}
 
 @node User name and password
 @type interstitial
-@next 
+@next
 (if (assistant-password-required-p)
     "Enter user name and password"
   "Want user name and password?")
diff --git a/lisp/gnus/gnus-demon.el b/lisp/gnus/gnus-demon.el
index 7ec471afc7..b4b9b62a4f 100644
--- a/lisp/gnus/gnus-demon.el
+++ b/lisp/gnus/gnus-demon.el
@@ -252,7 +252,8 @@ gnus-demon-scan-news
 	(save-window-excursion
 	  (when (gnus-alive-p)
 	    (with-current-buffer gnus-group-buffer
-	      (gnus-group-get-new-news))))
+	      (gnus-group-get-new-news nil nil
+                                       gnus-threaded-get-unread-articles))))
       (set-window-configuration win))))
 
 (defun gnus-demon-add-scan-timestamps ()
diff --git a/lisp/gnus/gnus-group.el b/lisp/gnus/gnus-group.el
index 742f8f4be5..19090c68ff 100644
--- a/lisp/gnus/gnus-group.el
+++ b/lisp/gnus/gnus-group.el
@@ -4014,13 +4014,15 @@ gnus-activate-all-groups
 	(gnus-activate-foreign-newsgroups level))
     (gnus-group-get-new-news)))
 
-(defun gnus-group-get-new-news (&optional arg one-level)
+(defun gnus-group-get-new-news (&optional arg one-level background)
   "Get newly arrived articles.
 If ARG is a number, it specifies which levels you are interested in
 re-scanning.  If ARG is non-nil and not a number, this will force
 \"hard\" re-reading of the active files from all servers.
 If ONE-LEVEL is not nil, then re-scan only the specified level,
-otherwise all levels below ARG will be scanned too."
+otherwise all levels below ARG will be scanned too.
+If BACKGROUND then run `gnus-get-unread-articles' in a separate thread.
+"
   (interactive "P")
   (require 'nnmail)
   (let ((gnus-inhibit-demon t)
@@ -4034,17 +4036,13 @@ gnus-group-get-new-news
     (unless gnus-slave
       (gnus-master-read-slave-newsrc))
 
-    (gnus-get-unread-articles (gnus-group-default-level arg t)
-			      nil one-level)
+    (gnus-get-unread-articles arg nil one-level background)
 
     ;; If the user wants it, we scan for new groups.
     (when (eq gnus-check-new-newsgroups 'always)
       (gnus-find-new-newsgroups))
 
-    (gnus-check-reasonable-setup)
-    (gnus-run-hooks 'gnus-after-getting-new-news-hook)
-    (gnus-group-list-groups (and (numberp arg)
-				 (max (car gnus-group-list-mode) arg)))))
+    (gnus-check-reasonable-setup)))
 
 (defun gnus-group-get-new-news-this-group (&optional n dont-scan)
   "Check for newly arrived news in the current group (and the N-1 next groups).
diff --git a/lisp/gnus/gnus-start.el b/lisp/gnus/gnus-start.el
index e142c438ee..4553fa2d78 100644
--- a/lisp/gnus/gnus-start.el
+++ b/lisp/gnus/gnus-start.el
@@ -36,6 +36,7 @@
 (autoload 'gnus-agent-save-local "gnus-agent")
 (autoload 'gnus-agent-possibly-alter-active "gnus-agent")
 (declare-function gnus-group-decoded-name "gnus-group" (string))
+(declare-function gnus-group-default-level "gnus-group")
 
 (eval-when-compile (require 'cl-lib))
 
@@ -377,6 +378,17 @@ gnus-options-not-subscribe
   :type '(choice regexp
 		 (const :tag "none" nil)))
 
+(defcustom gnus-threaded-get-unread-articles nil
+  "Instantiate parallel threads for `gnus-get-unread-articles' which encapsulates
+most of the network retrieval when `gnus-group-get-new-news' is run."
+  :group 'gnus-start
+  :type 'boolean
+  :set (lambda (symbol value)
+         (set-default symbol value)
+         (when value (unless (featurep 'threads)
+                       (set-default symbol nil)
+                       (gnus-message 5 "Threads unsupported")))))
+
 (defcustom gnus-modtime-botch nil
   "Non-nil means .newsrc should be deleted prior to save.
 Its use is due to the bogus appearance that .newsrc was modified on
@@ -755,7 +767,8 @@ gnus-1
 	(gnus-group-get-new-news
 	 (and (numberp arg)
 	      (> arg 0)
-	      (max (car gnus-group-list-mode) arg))))
+	      (max (car gnus-group-list-mode) arg))
+         nil gnus-threaded-get-unread-articles))
 
     (gnus-clear-system)
     (gnus-splash)
@@ -1580,9 +1593,82 @@ gnus-get-unread-articles-in-group
 	(setcar (gnus-group-entry (gnus-info-group info)) num))
       num)))
 
-;; Go though `gnus-newsrc-alist' and compare with `gnus-active-hashtb'
-;; and compute how many unread articles there are in each group.
-(defun gnus-get-unread-articles (&optional level dont-connect one-level)
+(defun gnus-instantiate-server-buffer (name)
+  (let ((buffer (generate-new-buffer (format " *gnus-thread %s*" name))))
+    (nnheader-prep-server-buffer buffer)
+    buffer))
+
+(defmacro gnus-get-unread-articles-pass-preceding (f args)
+  "Tack preceding return value to ARGS before applying F."
+  `(apply ,f (nconc ,args (list (and (boundp 'gnus-run-thread--subresult)
+                                     gnus-run-thread--subresult)))))
+
+(defvar gnus-newsgroup-marked)
+(defvar gnus-newsgroup-spam-marked)
+(defvar gnus-article-current)
+(defvar gnus-current-score-file)
+(defvar gnus-newsgroup-charset)
+(defun gnus-thread-body (thread-name mtx working fns)
+  (with-mutex mtx
+    (nnheader-message 9 "gnus-thread-body: start %s" thread-name)
+    (let (gnus-run-thread--subresult
+          current-fn
+          (nntp-server-buffer working)
+          (gnus-newsgroup-name gnus-newsgroup-name)
+          (gnus-newsgroup-marked gnus-newsgroup-marked)
+          (gnus-newsgroup-spam-marked gnus-newsgroup-spam-marked)
+          (gnus-newsgroup-unreads gnus-newsgroup-unreads)
+          (gnus-current-headers gnus-current-headers)
+          (gnus-newsgroup-data gnus-newsgroup-data)
+          (gnus-summary-buffer gnus-summary-buffer)
+          (gnus-article-buffer gnus-article-buffer)
+          (gnus-original-article-buffer gnus-original-article-buffer)
+          (gnus-article-current gnus-article-current)
+          (gnus-reffed-article-number gnus-reffed-article-number)
+          (gnus-current-score-file gnus-current-score-file)
+          (gnus-newsgroup-charset gnus-newsgroup-charset))
+      (condition-case err
+          (dolist (fn fns)
+            (setq current-fn fn)
+            (setq gnus-run-thread--subresult (funcall fn)))
+        (error (nnheader-message
+                4 "gnus-thread-body: '%s' in %S"
+                (error-message-string err) current-fn))))
+    (kill-buffer working)
+    (nnheader-message 9 "gnus-thread-body: finish %s" thread-name)))
+
+(defun gnus-run-thread (mtx thread-group &rest fns)
+  "MTX, if non-nil, is the mutex for the new thread.
+THREAD-GROUP is string useful for naming working buffer and threads.
+All FNS must finish before MTX is released."
+  (when fns
+    (let ((thread-name
+           (concat thread-group "-"
+                   (let* ((max-len 160)
+                          (full-name (pp-to-string (car fns)))
+                          (short-name (cl-subseq
+                                       full-name 0
+                                       (min max-len
+                                            (length full-name)))))
+                     (if (> (length full-name) (length short-name))
+                         (concat short-name "...")
+                       short-name)))))
+      (make-thread (apply-partially
+                    #'gnus-thread-body
+                    thread-name mtx
+                    (gnus-instantiate-server-buffer thread-group)
+                    fns)
+                   thread-name))))
+
+(defvar gnus-mutex-get-unread-articles (make-mutex "gnus-mutex-get-unread-articles")
+  "Updating or displaying state of unread articles are critical sections.")
+
+(cl-defun gnus-get-unread-articles (&optional requested-level dont-connect
+                                              one-level background
+                                    &aux (level (gnus-group-default-level
+                                                 requested-level t)))
+  "Go through `gnus-newsrc-alist' and compare with `gnus-active-hashtb'
+  and compute how many unread articles there are in each group."
   (setq gnus-server-method-cache nil)
   (require 'gnus-agent)
   (let* ((newsrc (cdr gnus-newsrc-alist))
@@ -1636,14 +1722,14 @@ gnus-get-unread-articles
 		'primary)
 	       (t
 		'foreign)))
-	(push (setq method-group-list (list method method-type nil nil))
+	(push (setq method-group-list (list method method-type nil))
 	      type-cache))
       ;; Only add groups that need updating.
       (if (or (and foreign-level (null (numberp foreign-level)))
-	   (funcall (if one-level #'= #'<=) (gnus-info-level info)
-		    (if (eq (cadr method-group-list) 'foreign)
-			foreign-level
-		      alevel)))
+	      (funcall (if one-level #'= #'<=) (gnus-info-level info)
+		       (if (eq (cadr method-group-list) 'foreign)
+			   foreign-level
+		         alevel)))
 	  (setcar (nthcdr 2 method-group-list)
 		  (cons info (nth 2 method-group-list)))
 	;; The group is inactive, so we nix out the number of unread articles.
@@ -1664,9 +1750,9 @@ gnus-get-unread-articles
 		     (gnus-method-rank (cadr c2) (car c2))))))
     ;; Go through the list of servers and possibly extend methods that
     ;; aren't equal (and that need extension; i.e., they are async).
-    (let ((methods nil))
+    (let (methods)
       (dolist (elem type-cache)
-	(cl-destructuring-bind (method method-type infos dummy) elem
+	(cl-destructuring-bind (method method-type infos) elem
 	  (let ((gnus-opened-servers methods))
 	    (when (and (gnus-similar-server-opened method)
 		       (gnus-check-backend-function
@@ -1687,68 +1773,107 @@ gnus-get-unread-articles
 	  (with-current-buffer nntp-server-buffer
 	    (gnus-read-active-file-1 method nil)))))
 
-    ;; Clear out all the early methods.
-    (dolist (elem type-cache)
-      (cl-destructuring-bind (method method-type infos dummy) elem
-	(when (and method
-		   infos
-		   (gnus-check-backend-function
-		    'retrieve-group-data-early (car method))
-		   (not (gnus-method-denied-p method)))
-	  (when (ignore-errors (gnus-get-function method 'open-server))
-	    (unless (gnus-server-opened method)
-	      (gnus-open-server method))
-	    (when (gnus-server-opened method)
-	      ;; Just mark this server as "cleared".
-	      (gnus-retrieve-group-data-early method nil))))))
-
-    ;; Start early async retrieval of data.
-    (let ((done-methods nil)
-	  sanity-spec)
-      (dolist (elem type-cache)
-	(cl-destructuring-bind (method method-type infos dummy) elem
-	  (setq sanity-spec (list (car method) (cadr method)))
-	  (when (and method infos
-		     (not (gnus-method-denied-p method)))
-	    ;; If the open-server method doesn't exist, then the method
-	    ;; itself doesn't exist, so we ignore it.
-	    (if (not (ignore-errors (gnus-get-function method 'open-server)))
-		(setq type-cache (delq elem type-cache))
-	      (unless (gnus-server-opened method)
-		(gnus-open-server method))
-	      (when (and
-		     ;; This is a sanity check, so that we never
-		     ;; attempt to start two async requests to the
-		     ;; same server, because that will fail.  This
-		     ;; should never happen, since the methods should
-		     ;; be unique at this point, but apparently it
-		     ;; does happen in the wild with some setups.
-		     (not (member sanity-spec done-methods))
-		     (gnus-server-opened method)
-		     (gnus-check-backend-function
-		      'retrieve-group-data-early (car method)))
-		(push sanity-spec done-methods)
-		(when (gnus-check-backend-function 'request-scan (car method))
-		  (gnus-request-scan nil method))
-		;; Store the token we get back from -early so that we
-		;; can pass it to -finish later.
-		(setcar (nthcdr 3 elem)
-			(gnus-retrieve-group-data-early method infos))))))))
-
-    ;; Do the rest of the retrieval.
-    (dolist (elem type-cache)
-      (cl-destructuring-bind (method method-type infos early-data) elem
-	(when (and method infos
-		   (not (gnus-method-denied-p method)))
-	  (let ((updatep (gnus-check-backend-function
-			  'request-update-info (car method))))
-	    ;; See if any of the groups from this method require updating.
-	    (gnus-read-active-for-groups method infos early-data)
-	    (dolist (info infos)
-	      (inline (gnus-get-unread-articles-in-group
-		       info (gnus-active (gnus-info-group info))
-		       updatep)))))))
-    (gnus-message 6 "Checking new news...done")))
+    ;; Must be able to `gnus-open-server'
+    (setq type-cache (seq-filter
+                      (lambda (elem)
+                        (cl-destructuring-bind (method _type _infos) elem
+                          (ignore-errors (gnus-get-function method 'open-server))))
+                      type-cache))
+
+    (let (methods
+          (coda (apply-partially
+                 (lambda (level*)
+                   (nnheader-message 9 "gnus-get-unread-articles: all done")
+                   (gnus-group-list-groups level*)
+                   (gnus-run-hooks 'gnus-after-getting-new-news-hook)
+                   (gnus-group-list-groups))
+                 (and (numberp level)
+                      (max (car gnus-group-list-mode) level)))))
+      (mapc (lambda (elem)
+              (cl-destructuring-bind
+                (method _type infos
+                 &aux
+                 (backend (car method))
+                 (already-p
+                  (cl-some (apply-partially
+                            #'gnus-methods-equal-p method)
+                           methods))
+                 (denied-p (gnus-method-denied-p method))
+                 (scan-p (gnus-check-backend-function 'request-scan backend))
+                 (early-p (gnus-check-backend-function
+                           'retrieve-group-data-early backend))
+                 (update-p (gnus-check-backend-function
+                            'request-update-info backend))
+                 commands early-data)
+                  elem
+                (when (and method infos (not denied-p) (not already-p))
+                  (push method methods)
+                  (gnus-push-end (apply-partially
+                                  #'gnus-open-server method)
+                                 commands)
+                  (when early-p
+                    ;; Just mark this server as "cleared".
+                    (gnus-push-end (apply-partially
+                                    #'gnus-retrieve-group-data-early method nil)
+                                   commands)
+
+                    ;; This is a sanity check, so that we never
+                    ;; attempt to start two async requests to the
+                    ;; same server, because that will fail.  This
+                    ;; should never happen, since the methods should
+                    ;; be unique at this point, but apparently it
+                    ;; does happen in the wild with some setups.
+                    (when scan-p
+                      (gnus-push-end (apply-partially #'gnus-request-scan nil method)
+                                     commands))
+
+                    ;; Store the token we get back from -early so that we
+                    ;; can pass it to -finish later.
+                    (gnus-push-end (apply-partially
+                                    #'gnus-retrieve-group-data-early
+                                    method infos)
+                                   commands))
+                  (gnus-push-end (apply-partially
+                                  (lambda (f &rest args)
+                                    (gnus-get-unread-articles-pass-preceding f args))
+                                  #'gnus-read-active-for-groups method infos)
+                                 commands)
+                  (gnus-push-end (apply-partially
+                                  (lambda (infos* update-p*)
+                                    (mapc (lambda (info)
+                                            (gnus-get-unread-articles-in-group
+                                             info
+                                             (gnus-active (gnus-info-group info))
+                                             update-p*))
+                                          infos*)
+                                    (gnus-message 6 "Checking new news...done"))
+                                  infos update-p)
+                                 commands)
+                  (if background
+                      (let ((thread-group "gnus-unread-articles"))
+                        (add-function
+                         :before-while coda
+                         (apply-partially
+                          (lambda (thread-group* &rest _args)
+                            "Proceed with before-while if I'm the last one."
+                            (<= (cl-count thread-group*
+                                          (all-threads)
+                                          :test (lambda (s thr)
+                                                  (cl-search s (thread-name thr))))
+                                1))
+                          thread-group))
+                        (gnus-push-end coda commands)
+                        (apply #'gnus-run-thread
+                               gnus-mutex-get-unread-articles
+                               thread-group
+                               commands))
+                    (let (gnus-run-thread--subresult)
+                      (mapc (lambda (fn)
+                              (setq gnus-run-thread--subresult (funcall fn)))
+                            commands))))))
+            type-cache)
+      (unless background
+        (funcall coda)))))
 
 (defun gnus-method-rank (type method)
   (cond
@@ -1780,7 +1905,7 @@ gnus-read-active-for-groups
        early-data
        (gnus-check-backend-function 'finish-retrieve-group-infos (car method))
        (or (not (gnus-agent-method-p method))
-	   (gnus-online method)))
+           (gnus-online method)))
       (gnus-finish-retrieve-group-infos method infos early-data)
       ;; We may have altered the data now, so mark the dribble buffer
       ;; as dirty so that it gets saved.
@@ -1789,12 +1914,12 @@ gnus-read-active-for-groups
      ;; Most backends have -retrieve-groups.
      ((gnus-check-backend-function 'retrieve-groups (car method))
       (when (gnus-check-backend-function 'request-scan (car method))
-	(gnus-request-scan nil method))
+        (gnus-request-scan nil method))
       (let (groups)
-	(gnus-read-active-file-2
-	 (dolist (info infos (nreverse groups))
-	   (push (gnus-group-real-name (gnus-info-group info)) groups))
-	 method)))
+        (gnus-read-active-file-2
+         (dolist (info infos (nreverse groups))
+           (push (gnus-group-real-name (gnus-info-group info)) groups))
+         method)))
      ;; Virtually all backends have -request-list.
      ((gnus-check-backend-function 'request-list (car method))
       (gnus-read-active-file-1 method nil))
@@ -1802,7 +1927,7 @@ gnus-read-active-for-groups
      ;; by one.
      (t
       (dolist (info infos)
-	(gnus-activate-group (gnus-info-group info) nil nil method t))))))
+        (gnus-activate-group (gnus-info-group info) nil nil method t))))))
 
 (defun gnus-make-hashtable-from-newsrc-alist ()
   "Create a hash table from `gnus-newsrc-alist'.
@@ -2042,9 +2167,7 @@ gnus-read-active-file-1
     (gnus-message 5 "%s" mesg)
     (when (gnus-check-server method)
       ;; Request that the backend scan its incoming messages.
-      (when (and (or (and gnus-agent
-			  (gnus-online method))
-		     (not gnus-agent))
+      (when (and (or (not gnus-agent) (gnus-online method))
 		 (gnus-check-backend-function 'request-scan (car method)))
 	(gnus-request-scan nil method))
       (cond
diff --git a/lisp/gnus/gnus-sum.el b/lisp/gnus/gnus-sum.el
index f21bc7584e..6f12ae6c13 100644
--- a/lisp/gnus/gnus-sum.el
+++ b/lisp/gnus/gnus-sum.el
@@ -7764,8 +7764,7 @@ gnus-summary-display-article
     (setq gnus-article-charset gnus-newsgroup-charset)
     (setq gnus-article-ignored-charsets gnus-newsgroup-ignored-charsets)
     (mm-enable-multibyte))
-  (if (null article)
-      nil
+  (when article
     (prog1
 	(funcall (or gnus-summary-display-article-function
                      #'gnus-article-prepare)
diff --git a/lisp/gnus/gnus-util.el b/lisp/gnus/gnus-util.el
index 3cf364fff8..48b0739dd1 100644
--- a/lisp/gnus/gnus-util.el
+++ b/lisp/gnus/gnus-util.el
@@ -106,6 +106,9 @@ gnus-eval-in-buffer-window
 (put 'gnus-eval-in-buffer-window 'lisp-indent-function 1)
 (put 'gnus-eval-in-buffer-window 'edebug-form-spec '(form body))
 
+(defmacro gnus-push-end (elt place)
+  `(push ,elt (if (consp ,place) (cdr (last ,place)) ,place)))
+
 (defsubst gnus-goto-char (point)
   (and point (goto-char point)))
 
diff --git a/lisp/gnus/nnheader.el b/lisp/gnus/nnheader.el
index 28c4cebb2d..d5d76e80ea 100644
--- a/lisp/gnus/nnheader.el
+++ b/lisp/gnus/nnheader.el
@@ -502,11 +502,10 @@ nnheader-file-coding-system
   "Coding system used in file backends of Gnus.")
 (defvar nnheader-callback-function nil)
 
-(defun nnheader-init-server-buffer ()
-  "Initialize the Gnus-backend communication buffer."
-  (unless (gnus-buffer-live-p nntp-server-buffer)
-    (setq nntp-server-buffer (get-buffer-create " *nntpd*")))
-  (with-current-buffer nntp-server-buffer
+(defsubst nnheader-prep-server-buffer (buffer)
+  "Refactor \"setting the table\" of BUFFER for `nnheader-init-server-buffer' and
+`gnus-instantiate-server-buffer'."
+  (with-current-buffer buffer
     (erase-buffer)
     (mm-enable-multibyte)
     (kill-all-local-variables)
@@ -514,6 +513,12 @@ nnheader-init-server-buffer
     (set (make-local-variable 'nntp-process-response) nil)
     t))
 
+(defun nnheader-init-server-buffer ()
+  "Initialize the Gnus-backend communication buffer."
+  (unless (gnus-buffer-live-p nntp-server-buffer)
+    (setq nntp-server-buffer (get-buffer-create " *nntpd*")))
+  (nnheader-prep-server-buffer nntp-server-buffer))
+
 ;;; Various functions the backends use.
 
 (defun nnheader-file-error (file)
diff --git a/lisp/gnus/nnimap.el b/lisp/gnus/nnimap.el
index 1ec5522831..64f7cb46d6 100644
--- a/lisp/gnus/nnimap.el
+++ b/lisp/gnus/nnimap.el
@@ -371,6 +371,19 @@ nnimap-make-process-buffer
 		      :initial-resync 0))
     (push (list buffer (current-buffer)) nnimap-connection-alist)
     (push (current-buffer) nnimap-process-buffers)
+    (with-current-buffer buffer
+      (add-hook 'kill-buffer-hook
+                (apply-partially
+                 (lambda (buffer)
+                   (when-let ((pbuffer
+                               (car (alist-get buffer nnimap-connection-alist))))
+                     (setq nnimap-process-buffers
+                           (delq pbuffer nnimap-process-buffers))
+                     (kill-buffer pbuffer) ;; should HUP its process
+                     (setq nnimap-connection-alist
+                           (assq-delete-all buffer nnimap-connection-alist))))
+                 buffer)
+                nil t))
     (current-buffer)))
 
 (defvar auth-source-creation-prompts)
diff --git a/lisp/gnus/nntp.el b/lisp/gnus/nntp.el
index 3ddd53e46c..044e032134 100644
--- a/lisp/gnus/nntp.el
+++ b/lisp/gnus/nntp.el
@@ -1301,6 +1301,19 @@ nntp-open-connection
 	  (prog1
 	      (caar (push (list process buffer nil) nntp-connection-alist))
 	    (push process nntp-connection-list)
+            (with-current-buffer buffer
+              (add-hook 'kill-buffer-hook
+                        (apply-partially
+                         (lambda (buffer)
+                           (when-let ((process
+                                       (car (nntp-find-connection-entry buffer))))
+                             (setq nntp-connection-list
+                                   (delq process nntp-connection-list))
+                             (setq nntp-connection-alist
+                                   (assq-delete-all process nntp-connection-alist))
+                             (ignore-errors (delete-process process))))
+                         buffer)
+                        nil t))
 	    (with-current-buffer pbuffer
 	      (nntp-read-server-type)
 	      (erase-buffer)
diff --git a/lisp/mh-e/mh-compat.el b/lisp/mh-e/mh-compat.el
index 7c5bd3a987..43669cc1af 100644
--- a/lisp/mh-e/mh-compat.el
+++ b/lisp/mh-e/mh-compat.el
@@ -47,8 +47,7 @@
 (mh-do-in-xemacs
   (defun mh-require (feature &optional filename noerror)
     "If feature FEATURE is not loaded, load it from FILENAME.
-If FEATURE is not a member of the list `features', then the feature
-is not loaded; so load the file FILENAME.
+Loaded features are recorded in the list variable `features'.
 If FILENAME is omitted, the printname of FEATURE is used as the file name.
 If the optional third argument NOERROR is non-nil,
 then return nil if the file is not found instead of signaling an error.
diff --git a/src/fns.c b/src/fns.c
index cbb6879223..7d4ed7cab6 100644
--- a/src/fns.c
+++ b/src/fns.c
@@ -2917,8 +2917,7 @@ require_unwind (Lisp_Object old_value)
 
 DEFUN ("require", Frequire, Srequire, 1, 3, 0,
        doc: /* If feature FEATURE is not loaded, load it from FILENAME.
-If FEATURE is not a member of the list `features', then the feature is
-not loaded; so load the file FILENAME.
+Loaded features are recorded in the list variable `features'.
 
 If FILENAME is omitted, the printname of FEATURE is used as the file
 name, and `load' will try to load this name appended with the suffix
-- 
2.23.0





Acknowledgement sent to dick.r.chiang@HIDDEN:
New bug report received and forwarded. Copy sent to bug-gnu-emacs@HIDDEN. Full text available.
Report forwarded to bug-gnu-emacs@HIDDEN:
bug#38136; Package emacs. Full text available.
Please note: This is a static page, with minimal formatting, updated once a day.
Click here to see this page with the latest information and nicer formatting.
Last modified: Mon, 25 Nov 2019 12:00:02 UTC

GNU bug tracking system
Copyright (C) 1999 Darren O. Benham, 1997 nCipher Corporation Ltd, 1994-97 Ian Jackson.